; GW48_1A_ASM on J16
; and win1_ass
;
; 23rd March 1999
;
; Alteration @ COMP_T4 to set A3 -> label info - 23rd March 1999
;
; A zero XREF_IX corrected at INS_END1 - 12th February 1999
;
; LIST/NOLIST added - 25th September 1998
;
	PWID	132
;
T_TBLE	DC.B	4         000 Normal number
	DC.B	4         001   "    PC
	DC.B	5         010 FBcc
	DC.B	0         011 Bcc
	DC.B	1         100 d(An)
	DC.B	2         101 LAB
	DC.B	0         110 d(An,Xn)
	DC.B	0         111 LAB(Xn)
;
; PASS2
;
; Release MAC_LST, 'P' chain and MINN space
;
PASS2	BTST	#5,DIP(A6)	LST? . .
	BEQ	PS_9		. . yes
	CLR.L	PRL(A6)		stop LIST/NOLIST
	BRA	PS_10
PS_9	MOVE.L	PRL(A6),D7	any LIST/NOLIST lines? . .
	BEQ	PS_10		. . no
	ADDQ.L	#8,D7		pointer to 1st Line no . .
	MOVE.L	D7,PRL_N(A6)	. . set in PRL_N
PS_10	LEA	MAC_BUF(A6),A0	set address . .
	MOVE.L	A0,BLSTCK(A6)	. . for BLSTCK
	MOVEQ	#1,D7     count
	MOVE.L	#CHLEN,D6 name chunk length
	LEA	MAC_LST(A6),A4
PS_1	MOVEQ	#2,D4     count
PS_2	MOVE.L	(A4)+,D5  1st address of strand
	BEQ.S	PS_3      no strand
PS_4	MOVEA.L	D5,A0
	MOVE.L	(A0,D7.W*4),D5      next chunk address
	MOVE.L	D6,D1     length of chunk
	LEA	HEAPAD(A6),A1
	MOVEA.W	MM_LNKFR,A2
	JSR	(A2)      link back MAC_LST or MINN
	TST.L	D5        more chunks? . . .
	BNE	PS_4      . . . yes
PS_3	DBF	D4,PS_2
	MOVE.L	#LLEN,D6  size of MINN chunks
	LEA	MINN(A6),A4
	DBF	D7,PS_1   now do MINN's
;
; Clear 'P' chain (if any)
;
	MOVEA.L	P_MAC(A6),A4	1st item
PS_7	MOVEA.L	A4,A0	this link
	MOVEA.L	(A4),A4	next link (if any)
	CMPA.W	#0,A0	is this a link? . .
	BEQ	PS_8	. . no
	MOVEQ	#8,D1	all are length 8
	LEA	HEAPAD(A6),A1
	MOVEA.W	MM_LNKFR,A2
	JSR	(A2)
	BRA	PS_7
PS_8	CLR.L	P_MAC(A6)
;
	MOVE.L	#504,D1   for BIN_LINE
	LEA	HEAPAD(A6),A0
	MOVEA.W	MM_ALLOC,A2
	JSR	(A2)
	TST.L	D0
	BNE	QER4     ---->
	MOVE.L	A0,BIN_LINE(A6)
	MOVE.L	#B_BUFSZE+6,D1
	LEA	HEAPAD(A6),A0
	MOVEA.W	MM_ALLOC,A2
	JSR	(A2)
	TST.L	D0
	BNE	QER4      ---->
	MOVE.L	A0,BIN_BUF(A6)
	CLR.W	4(A0)     mark empty
	MOVE.L	#T_BUFSZE+10,D1
	LEA	HEAPAD(A6),A0
	MOVEA.W	MM_ALLOC,A2
	JSR	(A2)
	TST.L	D0
	BNE	QER4      ---->
	MOVE.L	A0,TMP_BUF(A6)
	CLR.W	4(A0)     mark empty
	MOVEQ	#4,D1
	LSL.L	#8,D1     1024
	LEA	HEAPAD(A6),A0
	MOVEA.W	MM_ALLOC,A2
	JSR	(A2)
	TST.L	D0
	BNE	QER4      ---->
	MOVE.L	A0,TEMR_L(A6)
	BSR	FLUSH1
	TST.B	BATCH(A6)
	BEQ	PS_5
	LEA	HEAD3_B,A1   LF
	BRA	PS_6
PS_5	LEA	HEAD3,A1
PS_6	BSR	UMT       print "PASS 2" or LF
	MOVEA.L	ER_LST(A6),A2
	MOVEA.L	(A2),A2
	CLR.W	4(A2)     Mark end of ERRORS
	MOVE.W	#-1,CRT_SEC(A6)     set initial current section
	CLR.L	BIN_OUT(A6)         set _BIN pos. -> start
;
; If sizeless Bcc or BSR branches to the following
; instruction arrange for a .W branch
;
	MOVE.L	BIN_F(A6),D0
	BEQ	COMP_B    no inserts
	MOVEA.L	D0,A4
	ADDQ.L	#8,A4
	MOVE.L	A4,BINS(A6)
	MOVEA.L	(A4),A1   end of INS
	LEA	-6(A4),A4 startof INS - 10
BRAN	LEA	10(A4),A4 next INS
	CMPA.L	A1,A4
	BLT	BRAN5
	TST.L	([BINS,A6],-8)      more chunks? . .
	BEQ	COMP_B              . . no
	MOVEA.L	([BINS,A6],-8),A4
	ADDQ.L	#8,A4
	MOVE.L	A4,BINS(A6)
	MOVEA.L	(A4)+,A1
BRAN5	MOVE.L	(A4),D2
	BPL.S	BRAN      not variable
	MOVE.W	4(A4),D1  label no
	BSR	LNPTR     A0 -> LINN
	BTST	#5,TYPE(A0)	XREF? ...
	BEQ.S	BRAN2               ... no
	BTST	#0,1+TYPE(A0)	N? ...
	BNE	BRAN		... yes
	BTST	#2,REL_SWTCH(A6)    NON_PC? ...
	BEQ.S	BRAN3               ... no
	BFEXTU	7(A4){1:4},D0
	CMPI.B	#5,D0               LAB(PC)? ...
	BNE.S	BRAN3               ... no
	MOVEQ	#2,D0               compress 2
	BFINS	D0,(A4){1:3}        set actual adj to 2
	BRA.S	BRAN4
BRAN3	BFEXTU	(A4){1:3},D0        actual adj ...
BRAN4	BFINS	D0,(A4){5:3}        ... to max adj
	BRA	BRAN      and go back
BRAN2	CMPI.B	#24,7(A4)
	BNE.S	BRAN      not Bcc or BSR
	CMPI.W	#6,TYPE(A0)
	BNE	BRAN      not known PC
	ANDI.L	#$FFFFFF,D2   *     (section & PC)
	ADDQ.L	#4,D2         * + 4
	CMP.L	VAL(A0),D2
	BNE	BRAN      not -> following instruction
	MOVE.W	(A0),D2   section
	CMP.W	SEC(A4),D2          same as INS? ...
	BNE	BRAN                .... no
	MOVE.B	#$A2,(A4) set to .W
	BRA	BRAN      go for more
;
; Compress 'PC'
;
; SSECT returns 4*(no of sections) or zero if none
;
SSECT	MOVEQ	#0,D0
	MOVE.W	SEC_NO(A6),D0       highest section + 1
	BEQ.S	COMP_B3
	SUBQ.L	#1,D0
	LSL.L	#2,D0
COMP_B3	RTS
;
COMP_B	BSR	SSECT
	MOVE.W	D0,COMP_MARK(A6)    set to no of sections (or 0)
COMP_A	BCLR	#7,COMP_MARK(A6)
	MOVE.L	BIN_F(A6),D0
	BEQ	COMP2     no inserts
	MOVEA.L	D0,A4
	ADDQ.L	#8,A4
	MOVE.L	A4,BINS(A6)
	LEA	-6(A4),A4  start of BINS
COMP1	LEA	10(A4),A4
	CMPA.L	([BINS,A6]),A4
	BLT	COMP1_1   more
	TST.L	([BINS,A6],-8)      more chunks? . .
	BEQ	COMP2               . . no
	MOVEA.L	([BINS,A6],-8),A4
	ADDQ.L	#8,A4
	MOVE.L	A4,BINS(A6)
	ADDQ.L	#4,A4
COMP1_1	TST.B	(A4)      variable?
	BPL.S	COMP1     no
	MOVE.W	SEC(A4),D0          normal section no is -1
	BMI.S	COMP_T4             normal
	BFEXTU	COMP_MARK(A6){1:15},D2
	CMP.W	D0,D2
	BNE	COMP1     INS wrong section
COMP_T4	MOVE.W	4(A4),D1  label no
	MOVEA.L	A0,A3
	BSR	LNPTR     A0 -> LINN
	EXG	A0,A3     sets A3 -> LINN & restores A0
	MOVE.B	(A4),D0
	MOVE.B	D0,D2
	LSR.B	#4,D2
	EOR.B	D0,D2
	ANDI.B	#7,D2
	BEQ	COMP_T5   change not possible
	MOVE.W	TYPE(A3),D0
	MOVE.W	D0,D1
	ANDI.W	#3,D1
	BTST	#13,D0	XREF? . .
	BNE	COMP_T6	. . yes
	ANDI.W	#12,D0
	BEQ.S	COMP1  ---->
COMP_T6	BFEXTU	7(A4){1:4},D6     bits 3-6 of type INS
	CMPI.B	#11,D6
	BEQ.S	COMP_T1   FBcc
	CMPI.B	#13,D6
	BEQ.S	COMP_T2   PC or ZPC 'LAB'
	CMPI.B	#15,D6    PC or ZPC 'LAB(Xn)'? . . .
	BEQ	COMP_T2   . . . yes
	ANDI.B	#7,D6     cut off 'm'
	BNE.S	COMP_T    not ABS
	MOVEQ	#2,D6     to get type 5
	BRA.S	COMP_T
COMP_T2	BTST	#3,(A4)   1=ZPC 0=PC
	BEQ.S	COMP_T    PC
	MOVEQ	#0,D6
COMP_T1	ANDI.W	#2,D6
COMP_T	ANDI.W	#7,D6
	MOVE.B	T_TBLE(D6.W),CMP_TYPE(A6)
	LEA	O_BUF(A6),A0
	MOVEQ	#0,D6
	CMPI.B	#4,D0
	BEQ	COMP5     LABEL defined
	BTST	#13,D0	XREF? . .
	BNE	COMP5	. . yes
	MOVEA.L	BLSTCK(A6),A2
	MOVE.W	4(A4),(A2)+  set 1st EQU label in 'dup' list
	MOVEQ	#0,D2        mark "no 'PC'"
	MOVEA.L	A3,A1        -> LABEL for GLABA
	MOVEQ	#0,D3        + sign for GLABA
	MOVE.W	SEC(A4),D4   set D4 for <id> test in GLABA
	BSR	GLABA
	BPL.S	COMP_T3   OK - (not XREF)
	ADDQ.L	#1,D0
	BEQ	COMP1               error - go back
	BTST	#16,D2	'N'? . . (XREF)
	BEQ	COMP_XRF5	. . yes
COMP_XRF	BTST	#2,REL_SWTCH(A6)
	BEQ.S	COMP_XRF3           PC
COMP_XRF5	CMPI.B	#2,CMP_TYPE(A6)     LAB? ...
	BNE.S	COMP_XRF3           ... no
COMP_XRF2	MOVEQ	#2,D0
	BFINS	D0,(A4){1:3}        set actual adj to 2
	BRA.S	COMP_XRF4
COMP_XRF3	BFEXTU	(A4){1:3},D0        actual adj ...
COMP_XRF4	BFINS	D0,(A4){5:3}        ... to max adj
	BRA	COMP1     and go back
;
COMP_T5	BTST	#5,TYPE(A3)
	BNE	COMP_XRF
	BRA	COMP1
;
COMP_T3	MOVE.B	7(A4),D0
	SWAP	D2
	TST.W	D2        0='N' 1='PC' LABEL
	BEQ.S	COMP3     'N' type LABEL
	BTST	#3,D0
	BEQ	C_ERX     ----> INS type 'N'
COMP4	MOVEQ	#0,D3
	MOVE.B	6(A4),D3  w (must be 0 or 2)
	ADD.L	(A4),D3   *
	LSL.L	#8,D3
	MOVE.B	#-1,D3
	MOVE.L	D3,(A0)+  set -(*+w) in list
	BRA.S	COMP9
;
COMP3	BTST	#3,D0
	BEQ.S	COMP9     'N' type INS & LABEL
	BTST	#6,D0
	BNE	COMP9     'PC' & 'ZPC'
	ANDI.B	#%110000,D0
	BEQ.S	COMP9     Ord type where PC will collapse to N
	MOVE.B	#4,CMP_TYPE(A6)
	CMPI.B	#%110000,D0         LAB(Xn)
	BEQ.S	COMP9
	CMPI.B	#%100000,D0
	BNE	C_ERX     ---->
	MOVE.B	#3,CMP_TYPE(A6)   set CMP_TYPE 3
COMP9	LEA	O_BUF(A6),A2
	MOVE.L	A0,D0
	SUB.L	A2,D0
	BEQ	COMP8_2   no entries
	LSR.W	#2,D0
	BTST	#0,D0
	BNE	COMP1     no of PC must be even
	SUBQ.W	#2,D0
ORD3	MOVE.W	D0,D1
	LEA	O_BUF(A6),A2
	MOVEQ	#0,D4
ORD1	MOVE.L	(A2)+,D3
	CMP.L	(A2)+,D3
	BLE.S	ORD2      correct order
	MOVEQ	#1,D4     mark 'changed'
	MOVE.L	-4(A2),-8(A2)    switch
	MOVE.L	D3,-4(A2)
ORD2	DBF	D1,ORD1
	TST.B	D4
	BNE.S	ORD3
;
;   now get max/min for EQU & PC's
;         A0 -> end of PC's
;         D6 = constant
;
	MOVEQ	#0,D1     S(sign)
	CLR.L	-(A7)     space for
	CLR.L	-(A7)     S(max) & S(min)
	MOVE.L	BIN_L(A6),D0        last chunk
	BEQ	C_END     no inserts
	MOVEA.L	D0,A1     address of chunk
	MOVEQ	#0,D0
	LEA	O_BUF(A6),A3  list of PC's
PIGL5	ADDQ.L	#8,A1
	MOVEA.L	(A1),A2   end of inserts in chunk
	LEA	4(A1),A1  -> 1st insert in chunk
PIGL2	LEA	-10(A2),A2
	CMPA.L	A1,A2
	BGE	PIGL4
	TST.L	-8(A1)
	BEQ	C_END
	MOVEA.L	-8(A1),A1 address of previous block
	BRA	PIGL5
;
PIGL4	MOVE.L	(A2),D7
	BPL.S	PIGL2     to find 1st V_INS
	BTST	#7,4(A2)
	BNE.S	PIGL2     ignore negative LABELS (for ALIGN)
	ANDI.L	#$FFFFFF,D7
;
PIGL
	MOVE.L	-(A0),D2  PC|sign
	ADD.W	D0,D1
	CMPA.L	A3,A0
	BLT	C_END
	MOVE.B	D2,D0     new sign
	LSR.L	#8,D2     PCr-1
	EXT.W	D0
	BPL.S	PIGL1
	SUB.L	D2,D6
	BRA.S	PIGL3
PIGL1	ADD.L	D2,D6
	MOVEQ	#1,D0     set plus -> 1
PIGL3	CMP.L	D2,D7
	BLT.S	PIGL      find 1st PC<=INS *
	MOVEQ	#0,D4
	MOVEQ	#0,D5
	BRA.S	COMPUV
;
COMPST	LEA	-10(A2),A2 next INS 
	CMPA.L	A1,A2
	BGE	COMPST1
	TST.L	-8(A1)
	BEQ	COMQ      no more INS
	MOVEA.L	-8(A1),A1 -> previous chunk
	ADDQ.L	#8,A1
	MOVEA.L	(A1),A2
	LEA	-10(A2),A2    -> last item
	LEA	4(A1),A1      -> 1st item
COMPST1	MOVE.L	(A2),D7
	BPL.S	COMPST    not V_INS
	ANDI.L	#$FFFFFF,D7  INS_PC
	CMP.L	D2,D7
	BLT.S	COMQ      last INS_PC for this range
COMPUV	TST.B	D1
	BEQ.S	COMPST
	SWAP	D0
	MOVE.B	(A2),D0
	ANDI.W	#7,D0
	ADD.W	D0,D4
	MOVE.B	(A2),D0
	LSR.B	#4,D0
	ANDI.W	#7,D0     adj_in
	ADD.W	D0,D5
	SWAP	D0
	BRA.S	COMPST
;
COMQ	TST.B	D1
	BEQ.S	PIGL      nothing to do
	BPL.S	COMPP
	EXG	D4,D5
COMPP	MULS	D1,D4
	MULS	D1,D5
	SUB.L	D4,(A7)
	SUB.L	D5,4(A7)
	BRA.S	PIGL
;
COMP5	MOVE.B	7(A4),D0
	BTST	#3,D0
	BEQ.S	COMP8     INS(N)
	CMPI.B	#2,D1
	BEQ.S	COMP6_1   INS(PC) & LAB(PC)
	ANDI.B	#%110000,D0
	BEQ	COMP8_1   ord INS PC collapsing to N
	CMPI.B	#%110000,D0
	BNE.S	COMP5_1
	MOVE.B	#4,CMP_TYPE(A6)
	BRA	COMP8_1
COMP5_1	CMPI.B	#%100000,D0
	BNE.S	COMP6     not LAB type
	MOVE.B	#3,CMP_TYPE(A6)
	BRA.S	COMP8_3
COMP6	CMPI.W	#2,D1
	BNE.S	C_ERX     ----> not LAB(PC)
COMP6_1	BTST	#7,7(A4)
	BNE.S	C_ERX     ----> INS error
	MOVE.L	VAL(A3),D3          value of label
	MOVE.W	(A3),D2   section
	BMI.S	COMP6_2   non _REL
	BFEXTU	COMP_MARK(A6){1:15},D0
	CMP.W	D2,D0
	BNE	COMP_XRF  pseudo XREF
COMP6_2	LSL.L	#8,D3
	MOVE.B	#1,D3     + sign
	MOVE.L	D3,(A0)+  set 'PC' for LAB in list
	MOVE.L	#$10001,D2          mark 'PC' been & 'PC' type
	BRA	COMP4
;
COMP8	CMPI.W	#2,D1
	BEQ.S	C_ERX     ---->
COMP8_3	BTST	#5,TYPE(A3)	XREF? . .
	BEQ	COMP8_1		. . no
	BFEXTU	TYPE(A3){0:2},D3	0=B, 1=W, 2=L
	LSL.L	#3,D3
	MOVEQ	#1,D6
	LSL.L	D3,D6	sets D6 = 1 (B), $100 (W), $10000 (L)
	BRA	COMP8_2
COMP8_1	MOVE.L	VAL(A3),D6
COMP8_2	CLR.L	-(A7)
	CLR.L	-(A7)
	BRA.S	COMP7
;
C_END	TST.B	D1
	BEQ.S	COMP7
	ADDQ.L	#8,A7
C_ERX	MOVE.B	(A4),D0
	ANDI.B	#$F8,(A4)
	LSR.B	#4,D0
	ANDI.B	#7,D0     adj
	OR.B	D0,(A4)   set mx_in -> adj_in
	BRA	COMP1
COMP7	MOVE.B	CMP_TYPE(A6),D4
	EXT.W	D4
	LSL.W	#4,D4     set D4 to get parameters for COMY
	MOVE.L	D6,D3
	ADD.L	(A7)+,D6
	BSR	COMY
	MOVE.B	D0,D1     'LH'
	MOVE.L	D3,D6
	ADD.L	(A7)+,D6
	BSR	COMY      'LL'
	CMP.B	D0,D1
	BLE.S	COMP15
	EXG	D0,D1
COMP15	LSL.B	#4,D1
	ADD.B	D1,D0
	MOVE.B	(A4),D1
	ANDI.B	#$77,D1   keep max & adj
	EOR.B	D0,D1     change?
	BEQ	COMP1     no
	BSET	#7,COMP_MARK(A6)   mark change occurred
	EOR.B	D1,(A4)   put new max - adj in
	BRA	COMP1
;
COMP2	TST.W	COMP_MARK(A6)
	BMI	COMP_A    try more compression
	BEQ.S	ACOMP     ended
	SUBQ.W	#1,COMP_MARK(A6)    count down sections
	BRA	COMP_A    start next section
;
; Set PC's of negative LABELS to the required boundary
;
ACOMP	BSR	SSECT     D0 = no of sections - 1
	MOVE.W	D0,D4
ACOMP_4	MOVE.L	BIN_F(A6),D0
	BEQ	ACOMP_7
	MOVEA.L	D0,A1
	MOVEQ	#0,D0     Sadj
ACOMP_6	ADDQ.L	#8,A1
	MOVE.L	A1,BINS(A6)
	MOVEA.L	(A1)+,A2
ACOMP_1	MOVE.L	(A1),D1   INS adj|PC
	BPL	ACOMP_2   not wanted
	MOVE.W	8(A1),D3  section
	BMI	ACOMP_5   non _REL
	CMP.W	D3,D4     same section? ...
	BNE	ACOMP_2   ... no
ACOMP_5	MOVE.W	4(A1),D3  neg LABEL?
	BMI.S	ACOMP_3   yes
	BFEXTU	D1{1:3},D1
	ADD.L	D1,D0     Sadj
	BRA.S	ACOMP_2
ACOMP_3	NEG.W	D3
	SUBQ.W	#1,D3     l
	EXT.L	D3
	MOVE.L	D1,D2
	SUB.L	D0,D2     'PC'-Sadj=PC
	SUBQ.L	#2,D2      PC @ end (MOD 16)
	SUB.L	D3,D2     prepare for offset
	SWAP	D1
	LSR.W	#7,D1     top byte
	ANDI.L	#14,D1    2,6,14 adj
	AND.L	D1,D2     new adj
	ADD.L	D2,D0
	LSL.B	#3,D2
	ANDI.B	#$8F,(A1)
	OR.B	D2,(A1)   alter INSERT
ACOMP_2	LEA	10(A1),A1
	CMPA.L	A2,A1
	BLT.S	ACOMP_1   more
	TST.L	([BINS,A6],-8)      more chunks? . .
	BEQ	ACOMP_7             . . no
	MOVEA.L	([BINS,A6],-8),A1
	BRA	ACOMP_6
;
ACOMP_7	DBF	D4,ACOMP_4 do next section
;
;   Set true PC in LABELS after compression
; (Now actual adj is in Bits 0 to 2 of 1st byte of INS)
;   set EQU lists by GLAB and mark unknown labels XREF if UND_XREF is on
;
	MOVEQ	#1,D7     count (1st for TRUPC, 2nd for GLAB)
SETLAB9	MOVEQ	#3,D5     count four strands this time
	MOVEQ	#3,D2     lab no for 4th strand
	BRA.S	SETLAB1
SETLAB2	MOVE.W	SL1(A6,D5.W*2),D2   set label @ start of strand
SETLAB1	MOVE.W	D2,D1     label no -> D1 for LNPTR
	BSR	CHK_L     A0 -> LINN
	BEQ	SETLAB3   no strand
	BFEXTU	D1{24:6},D0         chunk offset (from byte 8)
	NEG.W	D0
	LEA	-8(A0,D0.W*8),A1    -> start of chunk
	SUBQ.W	#4,D2     prepare for counting label nos
SETLAB4	LEA	LLEN(A1),A2         -> end of chunk
	MOVEA.L	(A1),A1             -> next chunk
SETLAB5	ADDQ.W	#4,D2     advance lab no
	MOVE.W	TYPE(A0),D3
	MOVE.W	(A0),D4   section
	CMPI.W	#-2,D4    end of strand? ...
	BEQ	SETLAB3   ... yes
	TST.L	D7
	BEQ	SETLAB7   2nd time (GLAB)
	CMPI.B	#6,D3     PC type? ...
	BNE.S	SETLAB6   ... no
	MOVE.L	VAL(A0),D1          PC
	BSR	TRUPC
	MOVE.L	D1,VAL(A0)          true PC
	BRA	SETLAB6
;
SETLAB7	ANDI.W	#12,D3
	CMPI.W	#4,D3
	BGT.S	SETLAB8   EQ list
	BEQ	SETLAB6   nothing to do
	BTST	#5,TYPE(A0)
	BNE	SETLAB6   XREF
	BTST	#1,REL_SWTCH(A6)
	BEQ	SETLAB10	not UND_XREF
;
; Check if the label is a macro or not
;
	MOVEM.L	D3/A0/A2,-(A7)
	MOVE.W	D2,D3
	BSR	GNL	get A2 -> name
	BNE	SETLAB11	oops!
	CMPI.B	#$20,1(A2)	a macro? . .
	BEQ	SETLAB11	. . yes
	MOVEM.L	(A7)+,D3/A0/A2
	MOVE.W	#$A002,TYPE(A0)	set XREF, L and PC
	MOVE.W	XREF_NO(A6),VAL+2(A0)
	ADDQ.W	#1,XREF_NO(A6)
	BRA	SETLAB6
;
SETLAB11	MOVEM.L	(A7)+,D3/A0/A2
SETLAB10	CLR.W	TYPE(A0)
	BRA	SETLAB6
;
SETLAB8	MOVE.L	A2,-(A7)
	MOVEA.L	BLSTCK(A6),A2
	MOVE.W	D2,(A2)+  1st label no
	EXG	A0,A1
	MOVEQ	#-1,D3    set 1st section -1 and -1 in D3.top
	BSR	GLAB
	MOVEA.L	(A7)+,A2
	EXG	A0,A1
SETLAB6	LEA	8(A0),A0  next item
	CMPA.L	A2,A0     end of chunk? ...
	BLT	SETLAB5   ... no
	CMPA.L	#0,A1     more chunks? ...
	BEQ.S	SETLAB3   ... no
	LEA	8(A1),A0  -> 1st item
	BRA	SETLAB4
SETLAB3	DBF	D5,SETLAB2
	DBF	D7,SETLAB9
	BRA	GEQ1
;
; TRUPC sets true PC
;
;  On entry:- D1   = 'PC'  -   On exit:- D1 = PC
;             D4.W = section
;
;  Uses D0, D4 & A3
;
TRUPC	MOVEM.L	D2-3/A0,-(A7)
	MOVE.L	BIN_F(A6),D0
	BEQ	TRUPCEND1	no inserts so D1 is correct
	MOVEA.L	D0,A0
	ADDQ.L	#8,A0
	MOVE.L	A0,BINS(A6)
	MOVEA.L	(A0),A3   end of INS or chunk
	LEA	-6(A0),A0
	MOVEQ	#0,D2
TRUPC2	LEA	10(A0),A0
	CMPA.L	A3,A0
	BLT	TRUPC3
	TST.L	([BINS,A6],-8)      more? . .
	BEQ	TRUPCEND            . . no
	MOVEA.L	([BINS,A6],-8),A0
	ADDQ.L	#8,A0
	MOVE.L	A0,BINS(A6)
	MOVEA.L	(A0)+,A3
TRUPC3	MOVE.L	(A0),D0
	BPL.S	TRUPC2    not V_INS
	CMP.W	8(A0),D4  same section? ...
	BNE	TRUPC2    ... no
	MOVE.L	D0,D3
	ANDI.L	#$FFFFFF,D3     'PC'
	CMP.L	D3,D1
	BLE.S	TRUPCEND  no more INS needed
	BFEXTU	D0{1:3},D0
	BTST	#7,4(A0)  is LABEL NO -1?
	BEQ.S	TRUPC1    no
	ADD.L	D0,D0     for neg LABELS adj is in wds
TRUPC1	ADD.L	D0,D2
	BRA.S	TRUPC2
TRUPCEND	SUB.L	D2,D1
TRUPCEND1	MOVEM.L	(A7)+,D2-3/A0
	RTS
;
; To copy D2.W bytes from INPUT to OUTPUT
;
CI_O	MOVEQ	#-1,D3
	MOVE.L	D2,-(A7)  keep D2
	MOVEA.L	LBUF(A6),A1
	BSR	FETCHB    get D2.W bytes
	TST.B	REL_SWTCH(A6)
	BNE	CI_OLNK   linkable
	MOVEQ	#0,D1
	MOVEA.L	CH_OUT(A6),A0
	MOVEQ	#FS_POSRE,D0
	TRAP	#3
	MOVE.L	D1,D7
	MOVE.L	BIN_OUT(A6),D1
	MOVEQ	#FS_POSAB,D0
	TRAP	#3
	MOVEA.L	LBUF(A6),A1
	MOVE.L	(A7)+,D2  restore D2
	MOVEQ	#IO_SSTRG,D0
	TRAP	#3
	TST.L	D0
	BNE	QER1      ----> FATAL ERROR!!
	MOVEQ	#0,D1
	MOVEQ	#FS_POSRE,D0
	TRAP	#3
	LEA	BIN_OUT(A6),A1
	MOVE.L	D1,(A1)
	MOVE.L	D7,D1
	MOVEQ	#FS_POSAB,D0
	TRAP	#3
	RTS
;
CI_OLNK	MOVEA.L	LBUF(A6),A3
	MOVE.L	(A7)+,D2  restore count of bytes
	BRA	PFPUT
;
NOINS	DCB.L	3,0	3 long zero words
;
; When there are no INSERTS set A4 -> 0 and BINS(A6) -> a pointer
; to a zero word forwards and two long zeros backwards
;
GEQ2	LEA	8+NOINS,A4
	MOVE	A4,BINS(A6)
	SUBA.L	A4,A4
	BRA	GEQ3
;
GEQ1	MOVEA.L	CH_TMP(A6),A0
	MOVEQ	#-1,D3
	MOVE.L	#1000000,D1
	MOVEQ	#FS_POSAB,D0
	TRAP	#3
	CMPI.B	#-10,D0
	BNE	QER1      ----> not EOF!!
	MOVE.L	D1,([TMP_BUF,A6],6) set length of file
	MOVEQ	#0,D1
	MOVEQ	#FS_POSAB,D0
	TRAP	#3
	MOVEA.L	CH_OUT(A6),A0
	MOVEQ	#FS_POSAB,D0
	TRAP	#3
	CLR.L	LINE_NO(A6)
	MOVE.L	BIN_F(A6),BINS(A6)
	BEQ	GEQ2	mark no INSERTS
	ADDQ.L	#8,BINS(A6)
	MOVEA.L	BINS(A6),A4
	LEA	4(A4),A4
GEQ3	MOVE.L	PC_CS1(A6),PC_CS(A6) set to start of PC_LST
	MOVE.L	PC_CS1(A6),PC_TH(A6)
	ADDQ.L	#4,PC_TH(A6)        set pointer to 'this line'
	MOVEA.L	ER_LST(A6),A5
	LEA	4(A5),A5
	CLR.L	NO_ERRS(A6)
	CLR.L	NO_WARNS(A6)
	ST	BIN_SWTCH(A6) set switch for PASS2
	MOVEQ	#64,D0
GEQ4	CLR.L	PCW-4(A6,D0.W*4)    clear 65(!) PCW's
	DBF	D0,GEQ4
	CLR.L	DPCW(A6)
	LEA	O_BUF+4(A6),A0
	MOVE.L	A0,-4(A0) set 0_BUF for o/put to BIN
;
; Now set up FB directives (if linked o/put)
;
	TST.B	REL_SWTCH(A6)
	BEQ	PA_DB3    not linked o/put
;
; BUF entry
;         ________________________
;        | len | FB01 |<  prompt >|
;
	MOVE.W	#$FB01,2+BUF(A6)
	LEA	1+MOD_NME(A6),A3
	LEA	4+BUF(A6),A1
	BSR	XSYMB3    set prompt -> BUF
	ADDQ.W	#3,D3
	MOVE.W	D3,BUF(A6)          set length of XRF_LST item
	LEA	1+BUF(A6),A1
	BSR	PXPUT     send item to o/put
;
;  BUF entry for SECTIONS
;             _____________________________
;            | len | FB10 |< id >|< symbol>|
;
	MOVE.L	#$FB100000,BUF+2(A6)
	MOVEQ	#2,D2     sets bit 31 zero
	BSR	SXX
;
; BUF entry for XREF/XDEF
;
;     0_____2______4______6_____________
;    | len | FB10 |< id >|<symbol>| . .                XREF
;
;     _____32____34_____36___________________________
;     . . | len | FB06 |<symbol>|<value>|< id >| . . | XDEF
;
	MOVE.L	#$FB100000,BUF+2(A6)
	MOVE.W	#$FB06,BUF+34(A6)
	MOVEQ	#2,D2
	BSET	#31,D2
	MOVEA.L	TEMR_L(A6),A0
	LEA	4(A0),A1
	MOVE.L	A1,(A0)
	BSR	SXX
	BRA	PA_DB6
PA_DB	MOVE.L	DPCW(A6),D5  last lines total alt of PC
	BEQ.S	PA_DB3    if 0 don't set
	CLR.L	DPCW(A6)
	MOVE.W	CRT_SEC(A6),D2      section no
	ADD.L	D5,PCW(A6,D2.W*4)
PA_DB3	MOVEA.L	TEMR_L(A6),A0
	LEA	4(A0),A1
	MOVE.L	A1,(A0)
PA_DB6	TST.L	PRL(A6)		any LIST/NOLIST? . .
	BEQ	PA_DB15		. . no
	MOVE.L	([PRL_N,A6]),D5
	BCLR	#31,D5		next Line no
	CMP.L	LINE_NO(A6),D5	are we there yet? . .
	BGT	PA_DB15		. . no
	BTST	#7,([PRL_N,A6])	LIST or NOLIST? . .
	BEQ	PA_DB12		. . LIST
	BSET	#5,DIP(A6)
	BRA	PA_DB13
PA_DB12	BCLR	#5,DIP(A6)
PA_DB13	MOVEQ	#4,D5
	ADD.L	PRL_N(A6),D5	pointer to next Line no
	MOVEA.L	PRL(A6),A0	start of the current chunk
	LEA	PRL_INC_S(A0),A0	-> end
	CMP.L	A0,D5
	BLT	PA_DB14		still inside
	MOVE.L	PRL(A6),D5	start of next chunk (if any)
	MOVE.L	D5,PRL(A6)	update current chunk address
	ADDQ.L	#8,D5		pointer to next Line no . .
PA_DB14	MOVE.L	D5,PRL_N(A6)	. . set
PA_DB15	TST.L	XREF_IX(A6)
	BEQ	PA_DB11		none yet
	CLR.W	([XREF_IX,A6])
PA_DB11	TST.L	XREF_LST(A6)
	BEQ	PA_DB16		none yet
	CLR.B	([XREF_LST,A6])
PA_DB16	MOVE.L	([PC_TH,A6]),D5  PC @ start of line
	BSR	ST_LNO           step PC_LST pointer
	MOVE.L	([PC_TH,A6]),D2
	ANDI.L	#$FFFFFF,D5
	ANDI.L	#$FFFFFF,D2
	MOVEQ	#-1,D3    prepare for BIN_LINE
	MOVE.W	([PC_TH,A6],4),D0         section
	CMP.W	([PC_PR,A6],4),D0        same as old? ...
	BEQ	PA_DB2              ... yes
	MOVE.W	D0,CRT_SEC(A6)      alter current section
	LEA	BUF(A6),A1
	MOVE.L	#$4FB0400,(A1)
	CMPI.B	#1,CO_SE(A6,D0.W)
	BLT	PA_DB8		'SECTION'
	BEQ	PA_DB9		'COMMON'
	BSR	ORG_N		get ORG-name
	MOVE.W	D0,D7		keep section no
	BSR	NSECT_NO
	BNE	INS_ER61	---->	
	LEA	BUF(A6),A1
	MOVE.L	#$6FB0300,(A1)	set '6FB0300' for ORG
	MOVE.L	VAL(A0),3(A1)	set PC (=k)
	MOVE.L	VAL(A0),PCW(A6,D7.W*4)	set PC -> k
	BRA	PA_DB10
;
PA_DB9	MOVE.B	#$12,2(A1)	set '4FB1200' for COMMON
PA_DB8	NEG.W	D0
	SUBI.W	#1,D0
	MOVE.W	D0,3(A1)
PA_DB10	BCLR	#6,([PC_TH,A6]) was there rounding? ...
	BEQ.S	PA_DB4    ... no
	ADDQ.B	#1,(A1)	set new count
	MOVE.B	(A1),D2
	EXT.W	D2
	ADDA.W	D2,A1
	MOVEQ	#1,D2     to fetch one byte ...
	BSR	FETCHB
	CLR.B	-1(A1)    stop the byte being FB
	MOVE.W	CRT_SEC(A6),D0	current section
	ADDQ.L	#1,PCW(A6,D0.W*4)	advance PC
	LEA	BUF(A6),A1
PA_DB4	BSR	PXPUT     put BUF -> o/put
	MOVEQ	#0,D0     prepare for no BIN bytes
	BRA	PA_EX     nothing else this line
PA_DB2	SUB.L	D5,D2     No of bytes in line
	MOVEQ	#0,D0     Prepare for no BIN bytes
	MOVE.L	D2,D5
	BNE	PA_DB5    some bytes
	TST.B	REL_SWTCH(A6)
	BEQ	PA_EX     No bytes and not REL
	TST.L	BINS(A6)
	BEQ	PA_EX     no inserts
	CMPA.L	([BINS,A6]),A4
	BLT	PA_DB7    more
	TST.L	([BINS,A6],-8)
	BEQ	PA_EX     no more chunks
	MOVEA.L	([BINS,A6],-8),A4
	ADDQ.L	#8,A4
	MOVE.L	A4,BINS(A6)
	ADDQ.L	#4,A4     new A4
PA_DB7	CMPI.B	#-1,7(A4)
	BNE	PA_EX     next insert is not COMMENT
PA_DB5	CMPI.L	#500,D2
	BLE.S	PA_DB1    Normal
	MOVE.L	#500,D2   restrict to 500
PA_DB1	MOVEA.L	BIN_LINE(A6),A1
	MOVE.L	A1,D7
	SUB.L	D2,D5     extra bytes (if any)
	BSR	FETCHB    get D2.W bytes
	MOVEA.L	D7,A3     BIN_LINE->A3
;
; INSERTS
; D5 =0 normal >0 extra bytes to be copied
;                 after INSERTS
;
; Uses    D0 - 2/D4 -7
;
;          5 4 3 2 1 0
; LAB Type 0 0 0 0 0 0 Undefined
;          . . . . 0 1 N (number)
;          . . . . 1 0 PC
;          . . . . 1 1 Error
;          m m 0 0 . . Awaiting definition
;          m m 0 1 . . Defined
;          0 0 1 0 . . EQU list (not yet defined)
;
;        m m = 1 for FP numbers, 2 for Quad word, 3 for String
;
; At this stage the only values possible are
;   0 (no LABEL)
;   5  N
;   6  PC and
;   7  Error
;  21  FP
;  23  FP error
;  37  Quad word
;  39  Quad word error
;  53  String
;  55  String error
;
; The insert item is 10 bytes as shown:-
;
; |  B  |         3B        |     W    |   B  |7   3  0|     W    |
; |_____|___________________|__________|______|________|__________|
; |     |         *         | Label no |  w   |........|  Section |
;  V_code (PC where insert    (neg for            |  |
;             occurs)       ALIGN & CNOP)    0 + | N |
;                                            1 - |PC |
;   PC insert is [VAL(LABEL)-*-w]                |   |
;                                                   |
;                                                    |
;                          **************************|****************
;_________________         *                  Bits 4 | to 6          *
; V_code byte     |        *        Variable insert  | Normal insert *
; Bit 8           |        *  m00   Normal           | Normal        *
;  1 = Variable   |        *  001   BRA/BSR          | FP.S          *
;  0 = Not        |        *  m10   n(An)/LAB        | FP.D, quad    *
;                 |        *  m11   n(An,Xn)/LAB(Xn) | FP.X, FP.P, k *
;                 |        *  101   FBcc             | FBcc          *
; If Variable:    |        * m = 0,1 for 1st,2nd EA  | = 0 always    *
;                 |        **************************|****************
; Bits 4 to 6     |                                  
;  adj_in         |                Bits 0 to 2 (Normal - 4 to 6 = 0)
; (actual adj)    |  Value   type      range        where
; Bits 0 to 2     |   0      d3     1-8 -> 1-7,0   bits 9-11
;  mx_in          |   1      d4       4 bits       bits 0-3
; (potential adj) |   2   d8 or p8    8 bits       bits 0-7
;                 |   3  d16 or p16  16 bits       1 word
; If label no. neg|   4  d32 or p32  32 bits       2 words
; adj is in words |   5      d5_0     0 -> 31      bits 6-10
; else in bytes   |   6      d5_1   1-32 -> 1-31,0 bits 0-4
;                 |   7      d3       3 bits       bits 0-2
; Bit 3 is set    |
;  for ZPC        |                Bits 0 to 2 (Variable)
; (not normal)    | value = no of words between 1st EXT & *
;                 |
;   or ABS        |                Bits 0 to 2 (FP.X, FP.P, k)
;  (normal)       |                0 = FP.X, 1 = FP.P and 3 = k
;_________________|
;                                  Bits 0 to 2 (FP.D , quad)
;                                  0 = FP.D  1 = quad
INSERT	MOVEQ	#0,D3
	MOVE.L	([PC_PR,A6]),D7
	ANDI.L	#$FFFFFF,D7      'PC' @ start of line
	MOVE.L	([PC_TH,A6]),D0
	ANDI.L	#$FFFFFF,D0      'PC' @ end of line
	SUB.L	D7,D0
	MOVE.W	D0,D3       S(adj)|length of line
	MOVE.W	D0,D4
	SWAP	D4          keep length in D4(high)
;
; Note that if there no INSERTS A4 should be zero
; and BINS(A6) should point to a long zero forwards and
; two backwards
;
INS_LP	CMPA.L	([BINS,A6]),A4
	BLT	INS_LP5
	TST.L	([BINS,A6],-8)
	BEQ	INS_ENDA  no more inserts
	MOVEA.L	([BINS,A6],-8),A4
	ADDQ.L	#8,A4
	MOVE.L	A4,BINS(A6)
	ADDQ.L	#4,A4
INS_LP5	MOVE.W	SEC(A4),D1          section (could be -ve)
	CMP.W	CRT_SEC(A6),D1      same?
	BNE	INS_ENDA            no
	MOVE.B	7(A4),D4
	MOVE.L	(A4),D1
	ANDI.L	#$FFFFFF,D1    INS *
	SUB.L	D7,D1     position in BIN_LINE
	SWAP	D4
	CMPI.L	#500,D1   if D1>500 ....
	BGE	INS_END   ... there can't be an INSERT
	CMP.W	D4,D1
	BGT	INS_END   finished INSERT
	BNE	INS_LP4
	TST.W	D1
	BNE	INS_END   not 'COMMENT'
	SWAP	D4
	CMPI.B	#-1,D4    only 'COMMENT' should have INS type -1
	BNE	INS_ENDA  not 'COMMENT'
;
; The COMMENT is set up as:-
;
;  _____________________________
; | k1 | FB02 | k |<   string  >|
;
;  k1 = k + 3 : k = the length of < string >
;  (both k1 and k are bytes)
;
	MOVE.W	4(A4),D1  label no
	BSR	LNPTR
	MOVEA.L	A0,A1
	BFEXTU	TYPE(A1){10:2},D1
	CMPI.W	#3,D1
	BNE	INS_ER5   ----> not string
	MOVE.L	VAL(A1),D2          pointer to string
	BSR	INS_FXD   	D2->stack:A2->XREF_IX entry
	MOVE.W	#$8F8,(A2)+         set s,d = 8,-8
	MOVEA.L	A2,A0
	MOVE.W	([A7]),D2		length of string . .
	EXT.L	D2		. . to D2.L
	ADDQ.L	#4,D2		set no of bytes needed
	BSR	INS_FXL		A2 -> _LST
	MOVE.L	A2,(A0)		set pointer in _IX
	MOVE.L	A2,A0
	MOVE.W	#$FB02,1(A0)        set 'COMMENT' directive
	LEA	3(A0),A1	A1 is where string will go
	MOVEA.L	(A7)+,A3	retrieve pointer to name
	ADDQ.L	#1,A3
	BSR	XSYMB3	D3=length:string put
	ADDQ.W	#3,D3	k1
	MOVE.B	D3,(A0)
	CLR.W	D3        zero BIN bytes
	BRA	INS_LP1
;
; D4.top = type INS
;
INS_LP4	SWAP	D4
	BCLR	#7,D4
	MOVEA.L	A0,A1
	MOVE.L	D1,D0
	MOVE.W	4(A4),D1  LAB no
	BMI	INS_ALG   for ALIGN
	BSR	LNPTR     A0 -> LINN
	EXG	A0,A1
	MOVE.L	D0,D1
	BFEXTS	TYPE(A1){14:2},D0	bits 0 & 1
	BEQ	INS_ER4	---->
	ADDQ.L	#1,D0
	BEQ	INS_ER5	---->
	MOVE.W	TYPE(A1),D0
	BCLR	#6,D0	allow SET labels
	MOVE.L	VAL(A1),D2 LABEL VALUE
	CMPI.B	#$35,D0
	BEQ	INS_STR	string label
	BTST	#0,D0     N-LABEL? ...
	BNE	INS_D2A   ... yes
	TST.B	7(A4)     negative INS? ...
	BMI	INS_ER1   ---->
	BTST	#13,D0
	BNE	INS_D2B   XREF
	MOVE.W	(A1),D6   LABEL section
	CMP.W	CRT_SEC(A6),D6
	BNE	INS_D2C   set pseudo-XREF
	BTST	#3,D4     PC INS? ...
	BEQ	INS_D2E   .... no

;
; Set PC - * - w -> D2
;
	SUB.L	PCW(A6,D6.W*4),D2   -PCW
	SUB.L	D1,D2
	MOVE.L	D3,D6
	SWAP	D6
	EXT.L	D6        S(adj)
	ADD.L	D6,D2
INS_LPX2	ADDQ.L	#2,D2     [EXT]1
INS_LPX	MOVE.B	6(A4),D6  w
	EXTB.L	D6
	SUB.L	D6,D2
	BRA	INS_N2
;
; Now set D2 (roughly value of label)
;
; N-LABEL
;
INS_D2A	CMPI.B	#$15,D0
	BEQ	INS_FP    FP
	CMPI.B	#$25,D0
	BEQ	INS_FP    quad word
INS_D2A1	BTST	#13,D0    XREF? ...
	BEQ	INS_N1    ... no
	MOVEQ	#0,D2
	BRA	INS_N2
;
INS_STR	MOVEM.L	A0-1/D0,-(A7)
	MOVEA.L	D2,A1	pointer to string
	MOVEQ	#0,D2	prepare for answer
	MOVE.W	(A1)+,D0	length
	CMPI.W	#4,D0
	BLE	INS_STR1	fits in long word
	MOVEQ	#-10,D0	warning number
	BSR	INS_WARN
	MOVEQ	#4,D0	restrict length to 4
	BRA	INS_STR1
INS_STR2	LSL.L	#8,D2	room for next byte . .
	MOVE.B	(A1)+,D2	. . enter it
INS_STR1	DBF	D0,INS_STR2
	MOVEM.L	(A7)+,A0-1/D0
	BRA	INS_D2A1
;
; XREF or pseudo-XREF
;
INS_D2B	BTST	#3,D4     type INS N?
	BEQ	INS_D2D   ... yes
	BTST	#2,REL_SWTCH(A6)
	BNE	INS_D2D   NON_PC
	MOVEQ	#2,D2
	BRA	INS_LPX
;
INS_D2D	MOVEQ	#0,D2
	BRA	INS_N2
;
; to set pseudo-XREF
;
INS_D2C	BSET	#15,D0	set 'L' lengthh to mark error
	BTST	#3,D4     type INS N? ...
	BEQ	INS_D2E1  ... yes
	BTST	#2,REL_SWTCH(A6)
	BNE	INS_D2E1  NON_PC
	MOVEQ	#3,D6
	BFINS	D6,D0{18:2}
	BRA	INS_LPX2
;
; current section is in D6.W
; here we have PC label + N INS
; IF ORG - L, W, & B can be set else only L
;  because  of runtime relocation
;
INS_D2E	TST.B	REL_SWTCH(A6)
	BEQ	INS_ER5   ---->
	TST.B	(A4)	variable? . .
	BMI	INS_D2E1	. . yes
	CMPI.B	#4,D4
	BEQ	INS_D2E1	size L OK
	CMPI.B	#2,CO_SE(A6,D6.W)	ORG? . .
	BNE	INS_ER5	---->	. . no
INS_D2E1	MOVEQ	#3,D6
	BFINS	D6,D0{18:2}         mark pseudo-XREF
	BRA	INS_N2
;
INS_N1	BTST	#7,7(A4) plus?
	BEQ.S	INS_N2   yes
	NEG.L	D2
INS_N2	MOVE.W	D0,D6
	SWAP	D6        set LAB type to D6.top
	TST.B	(A4)
	BMI	INS_V1    Variable insert
	BTST	#3,D4     type of INS
	BEQ	INS_N     non variable 'N'
	BTST	#1,D0
	BEQ	INS_ER5   ----> not PC label
	CMPI.B	#$5C,D4
	BEQ	INS_XLP   long FPcc jump or XREF
	ANDI.B	#$F,D4    cut off FP marker
	SUBI.B	#11,D4
	BMI	INS_XP8
	BEQ	INS_XPD16
	BTST	#29,D6
	BNE	INS_XPD32
INS_LP3	MOVE.B	#$FF,-1(A3,D1.W)
INS_LP2	MOVE.L	D2,(A3,D1.W)
INS_LP1	LEA	10(A4),A4
	BRA	INS_LP
;
INS_ALG	MOVE.W	#6,D6    count for 14 bytes
	MOVE.L	A3,-(A7)
INS_ALGC	MOVE.W	#$4E71,(A3)+        NOP
	DBF	D6,INS_ALGC
	MOVEA.L	(A7)+,A3
	MOVE.B	(A4),D6
	LSR.W	#3,D6
	ANDI.W	#14,D6
	BSR	INS_VBIT
	LSR.W	#1,D6     no of words
	BRA.S	INS_ALG1
INS_ALG2	BCLR	D6,D3
INS_ALG1	DBF	D6,INS_ALG2
	BRA.S	INS_LP1
;
; D4 = 16,32,48,49 for .S .D .X .P
;
INS_FP	BTST	#13,D0    XREF? ...
	BNE	INS_ER5   ... yes - error
	BTST	#3,D4     PC type insert? ...
	BNE	INS_ER5   ... yes - error
	MOVEA.L	D2,A2     pointer to value
	CMPI.B	#$21,D4
	BEQ	INS_QA    quad word
	MOVEM.L	D3-4,-(A7)
	LEA	BUF(A6),A0
	MOVEQ	#2,D3
INS_FP3	MOVE.L	(A2)+,(A0)+
	DBF	D3,INS_FP3
	LEA	BUF(A6),A0
	CMPI.B	#32,D4
	BGT	INS_FP5   X or P
	PEA	INS_FP4
	BEQ	FP_XD     D
	BRA	FP_XS     S
;
INS_FP5	BTST	#0,D4
	BEQ.S	INS_FP4   X
	BSR	FP_XP     P
INS_FP4	MOVEM.L	(A7)+,D3-4
	BMI	INS_ER2   ---->
	LEA	BUF(A6),A2
	LSR.B	#4,D4     1,2,3
	EXT.W	D4        get rid of 3rd byte
	NEG.W	D4
	LEA	12(A2,D4.W*4),A2      set A2 to start of no.
	NEG.W	D4
	BRA	INS_FP2
INS_FP1	MOVE.L	(A2)+,(A3,D1.W)
	ADDQ.W	#4,D1
INS_FP2	DBF	D4,INS_FP1
	BRA	INS_LP1
;
INS_QA	MOVE.W	#2,D4     2 long words
	BRA.S	INS_FP2
;
INS_N	EXT.W	D4
	CMPI.W	#7,D4
	BGT	INS_K     error or 'k'
	LEA	N_TBLE,A2
	ADDA.W	(A2,D4.W*2),A2
	JMP	(A2)
;
INS_K	CMPI.B	#$33,D4   k? . . .
	BNE	INS_ER5   . . . no ---->
	BTST	#29,D6
	BNE	INS_ER63  ---->
	CMPI.L	#63,D2
	BGT	INS_ER2   ---->
	CMPI.L	#-64,D2
	BLT	INS_ER2   ---->
	OR.B	D2,3(A3)  put into second word of FMOVE
	BRA	INS_LP1
;
N_TBLE	DC.W	INS_D3-N_TBLE       INS 0
	DC.W	INS_D4-N_TBLE           1
	DC.W	INS_D8-N_TBLE           2
	DC.W	INS_XRD16-N_TBLE        3
	DC.W	INS_XD32-N_TBLE         4
	DC.W	INS_D5_0-N_TBLE         5
	DC.W	INS_D5_1-N_TBLE         6
	DC.W	INS_D3_1-N_TBLE         7
;
INS_D3_1	BTST	#29,D6
	BNE	INS_ER63  ---->
	CMPI.L	#7,D2
	BGT	INS_ER2   ---->
	CMPI.L	#0,D2
	BLT	INS_ER2   ---->
	TST.B	6(A4)     w
	BNE	INS_D3_2  special
	OR.B	D2,1(A3,D1.W)
	BRA	INS_LP1
INS_D3_2	BTST	#1,6(A4)
	BNE	INS_D3_3
	BFINS	D2,2(A3){3:3}
	BRA	INS_LP1
INS_D3_3	BFINS	D2,2(A3){8:3}
	BRA	INS_LP1
;
INS_D5_0	BTST	#29,D6
	BNE	INS_ER63  ---->
	CMPI.L	#31,D2
	BGT	INS_ER2   ---->
	CMPI.L	#0,D2
	BLT	INS_ER2   ---->
	LSL.W	#6,D2
	BRA.S	INS_D4A
;
INS_D5_1	BTST	#29,D6
	BNE	INS_ER63  ---->
	CMPI.L	#32,D2
	BGT	INS_ER2   ---->
	CMPI.L	#1,D2
	BLT	INS_ER2   ---->
	ANDI.W	#$1F,D2
	BRA.S	INS_D4A
;
INS_D3	BTST	#29,D6
	BNE	INS_ER63  ---->
	CMPI.L	#1,D2
	BLT	INS_ER2   ---->
	CMPI.L	#8,D2
	BGT	INS_ER2   ---->
	ANDI.B	#7,D2
	ADD.B	D2,D2
	ANDI.B	#$F1,(A3,D1.W)
	OR.B	D2,(A3,D1.W)
	BRA	INS_LP1
INS_D4	BTST	#29,D6
	BNE	INS_ER63  ---->
	CMPI.L	#0,D2
	BLT	INS_ER2   ---->
	CMPI.L	#15,D2
	BGT	INS_ER2   ---->
	TST.B	6(A4)     w
	BNE	INS_D4_1  special
	ANDI.W	#$FFF0,(A3,D1.W)
INS_D4A	OR.W	D2,(A3,D1.W)
	BRA	INS_LP1
INS_D4_1	BFINS	D2,2(A3){7:4}
	BRA	INS_LP1
INS_D8	BTST	#29,D6    XREF?
	BNE	INS_XD8   yes
	CMPI.L	#-128,D2
	BLT	INS_ER2   ---->
	CMPI.L	#255,D2
	BGT	INS_ER2   ---->
	MOVEQ	#0,D0
	MOVE.B	6(A4),D0  w
	SUB.W	D0,D1     adjust for DC.B
INS_D8L	MOVE.B	D2,1(A3,D1.W)
	BRA	INS_LP1
INS_D16	CMPI.L	#-32768,D2
	BLT	INS_ER2   ---->
	CMP.L	EXTBUF+4(A6),D2
	BGT	INS_ER2   ---->
INS_D16L	MOVE.W	D2,(A3,D1.W)
	BRA	INS_LP1
INS_P8	CMPI.L	#-128,D2
	BLT	INS_ER2   ---->
	CMPI.L	#127,D2
	BGT	INS_ER2   ---->
	TST.L	D2
	BNE	INS_D8L   not zero jump
	BSR	INS_BCC2  do WARNING/ERROR
	MOVE.W	#$4E71,(A3)  set NOP
	BRA	INS_LP1
;
INS_XD8	TST.B	REL_SWTCH(A6)	ORG? . .
	BMI	INS_XD8_3		. . yes
	BTST	#16,D6	'N' XREF? . .
	BEQ	INS_ER5	. . no ----> can't relocate PC XREF
INS_XD8_3	BSR	INS_FXD
	MOVE.B	#1,(A2)+  mark B in s of XREF_IX
	SWAP	D0
	MOVE.B	#9,D0     trunc to B signal
	SWAP	D0
	MOVE.B	6(A4),D6  w
	BNE	INS_XD8_1
INS_XD8_2	ADDQ.B	#1,D2     to 2nd byte
INS_XD8_1	MOVE.B	D2,(A2)+  set d of XREF_IX
	BRA	INS_XDA
;
; We are about to insert a word constant. If we have an XREF label
; or an EQU list containing an XREF label this is OK 1) if the type
; of label is 'N' or 2) if the type is 'PC' and ORG is on.
;
INS_XRD16	BTST	#2,(A4)   signed? ...
	BNE	INS_XRE16 ... yes
	MOVE.L	#65535,EXTBUF+4(A6)
	BRA	INS_XRF16
INS_XRE16	MOVE.L	#32767,EXTBUF+4(A6)
INS_XRF16	BTST	#29,D6
	BEQ	INS_D16	not XREF
	TST.B	REL_SWTCH(A6)	ORG? . .
	BMI	INS_XRG16		. . yes OK
	BTST	#16,D6
	BEQ	INS_ER5	PC label and not ORG ---->
INS_XRG16	BSR	INS_FXD   set D2, A2
	MOVE.B	#2,(A2)+  W
	SWAP	D0
	MOVE.B	#$A,D0
	SWAP	D0
	BRA.S	INS_XD8_1
INS_XD32	BTST	#29,D6    XREF? ...
	BEQ	INS_LP2   ... no
INS_XD32C	BSR	INS_FXD
	MOVE.B	#4,(A2)+  L
	SWAP	D0
	BTST	#17,D6
	BEQ.S	INS_XD32A   N-type label
	MOVE.B	#$54,D0   relocate, unsigned L
	BRA.S	INS_XD32B
INS_XD32A	MOVE.B	#$C,D0    L signal
INS_XD32B	SWAP	D0
	BRA	INS_XD8_1
;
; D0 = trunc rule|Type LABEL
; D6.top = Type LABEL
; A1 -> LABEL
; A2 -> the place in XREF_IX for the pointer to the FB...
; (A7) = constant
;
INS_XDA	MOVEA.L	A2,A0		keep place of _IX
	MOVEQ	#14,D2		arrange for 14 more bytes
	BSR	INS_FXL		A2 -> _LST
	MOVE.L	(A7)+,D2  restore D2
	MOVE.L	A2,(A0)		set pointer to FB strg in _IX . .
	MOVEA.L	A2,A0		. . and A0
	MOVE.W	#$FB07,1(A0)
	SWAP	D0
	MOVE.B	D0,7(A0)
	SWAP	D0
	BTST	#19,D6    EQU list? ...
	BEQ.S	INS_XDA1  ... no
	MOVEM.L	D0/D5,-(A7)
	BFEXTS	D6{13:3},D5
	ADDQ.L	#1,D5
	BEQ	INS_XDAE	---->	type 7 is error
	MOVEQ	#0,D5     S(PC)
	BSR	GLABB1    set XREFs for EQU list
	BPL.S	INS_XDA6  OK
INS_XDAE	MOVEM.L	(A7)+,D0/D5
	BRA	INS_ER64  ---->
INS_XDA6	TST.B	D5        should only 0 (N) or 1 (PC)
	BMI.S	INS_XDAE  ---->
	CMPI.B	#1,D5
	BGT.S	INS_XDAE  ---->
	MOVEM.L	(A7)+,D0/D5
	BSR	AGLB      do last bit
	BRA	INS_LP1
;
INS_XDA1	TST.B	REL_SWTCH(A6)	ORG? . .
	BPL	INS_XDA7		. . no
	BCLR	#6,7(A0)		clear relocation
INS_XDA7	MOVE.L	D2,3(A0)            add constant
	BTST	#28,D6    0=XREF 1=pseudo-XREF
	BNE	INS_XDA2
	MOVE.W	VAL+2(A1),9(A0)     set <id> for XREF
INS_XDA5	BTST	#7,7(A4)  +,-
	BEQ.S	INS_XDA3
	MOVE.B	#"-",8(A0)
	BRA.S	INS_XDA4
;
INS_XDA3	MOVE.B	#"+",8(A0)
INS_XDA4	MOVE.W	#$FB00,11(A0)
	MOVE.B	#11,(A0)  length
	BRA	INS_LP1
;
INS_XDA2	MOVE.W	(A1),D6	section
	CMPI.B	#2,CO_SE(A6,D6.W)	ORG? . .
	BEQ	INS_XDRG		. . yes
	NEG.W	D6
	SUBQ.W	#1,D6
	MOVE.W	D6,9(A0)  set <id>
	BRA	INS_XDA5
;
INS_XDRG	MOVE.W	#$FB00,8(A0)
	MOVE.B	#8,(A0)	length
	BRA	INS_LP1
;
INS_XLP	BTST	#29,D6
	BEQ	INS_LP2   not XREF
	BTST	#16,D6    1=N 0=PC
	BNE	INS_XLP5  N
	BTST	#3,7(A4)  PC INS? ...
	BNE	INS_XLP3  ... yes
	BTST	#28,D6    pseudo_XREF? ...
	BEQ	INS_MXRF2 ... no
	BRA	INS_MXRF1
INS_XLP3	BTST	#2,REL_SWTCH(A6)    NON_PC? ...
	BEQ	INS_XLP1            ... no
	MOVE.B	7(A4),D6
	ANDI.B	#%1111000,D6	bits 3-6 of INS type
	CMPI.B	#%0011000,D6           Bcc? ...
	BEQ	INS_XLP1            ... yes
	CMPI.B	#%1011000,D6           FBcc? ...
	BNE	INS_MXRF            ... no
INS_XLP1	SWAP	D0
	MOVE.B	#$2C,D0   trunc PC,L
INS_XLP4	SWAP	D0
	BSR	INS_FXD
	MOVE.B	#4,(A2)+  L
	BRA	INS_XD8_1
;
; PC type XREF with NON_PC LAB(Xn) or ([LAB ...
;
INS_MXRF	ANDI.B	#$F0,1(A3)          set 7(3) -> 6(0)
	BSET	#7,-1(A3,D1.W)      suppress base
INS_MXRF2	MOVEQ	#0,D2     zero constant for ABS
INS_MXRF1	SWAP	D0
	MOVE.B	#$54,D0   trunc ABS, L
	BRA	INS_XLP4
;
INS_XLP5	SWAP	D0
	MOVE.B	#$C,D0
	BRA	INS_XLP4
;
INS_XLP2	BTST	#29,D6
	BEQ	INS_LP3
INS_XPD32	MOVE.B	#$FF,-1(A3,D1.W)
	BRA	INS_XLP1
INS_XP8	BTST	#29,D6
	BEQ	INS_P8
	BSR	INS_FXD
	MOVE.B	#1,(A2)+  B
	SWAP	D0
	MOVE.B	#$29,D0   trunc PC,B
	SWAP	D0
	ADDQ.L	#1,(A7)	adjust constant for trunc PC
	BTST	#2,REL_SWTCH(A6)
	BEQ	INS_XD8_2	not NON_PC
	SUBQ.L	#2,(A7)	readjust if NON_PC
	BRA	INS_XD8_2
INS_XPD16	MOVE.L	#32767,EXTBUF+4(A6) set for signed comparison
	BTST	#29,D6
	BEQ	INS_D16
	BSR	INS_FXD
	MOVE.B	#2,(A2)+  W
	SWAP	D0
	MOVE.B	#$2A,D0   trunc PC,W
	SWAP	D0
	BRA	INS_XD8_1
;
; to find the place in XREF_IX & XREF_LST
; At entry D1 -> position in BIN_LINE
;
; XREF_IX is a dynamic buffer whose entries are:-
;     ________________________________
;    | s | d | Pointer to FB... string|
;
;  s=0 for end, 1 for B, 2 for W, 4 for L
;
; XREF_LST is a dynamic buffer in which each FB... string
; is made up. The buffer, initially zero, is expanded as needed.
;
; Each FB... string is preceded by a byte length
;  eg 'length FB01 <symbol>'.
;
; INS_FXD puts D2 on stack & sets D2.W=distance from last XREF
;
INS_FXD	MOVE.L	(A7),-(A7)          shift up return address
	MOVE.L	D2,4(A7)		keep
	MOVE.W	D1,D2		position in BIN_LINE
	MOVE.L	XREF_IX(A6),D1
	BEQ	INS_FXD3	no XREF_IX yet
INS_FXD2	TST.B	(D1.L)
	BEQ.S	INS_FXD3
	SUB.B	(D1.L),D2   -s
	SUB.B	1(D1.L),D2  -d
	ADDQ.L	#6,D1	step to next
	BRA.S	INS_FXD2
INS_FXD3	PEA	XREF_IX(A6)
	SUB.L	XREF_IX(A6),D1
	MOVE.L	D1,-(A7)
	ADDQ.L	#8,(A7)	ask for 8 more bytes
	PEA	0	no relocation
	BSR	GSP
	LEA	12(A7),A7	tidy the stack
	MOVEA.L	XREF_IX(A6),A2	set A2 . .
	ADDA.L	D1,A2		. . to current position
	CLR.W	6(A2)     clear the next entry
	RTS
;
; At entry D2.L = number of extra bytes needed
;
INS_FXL	MOVEM.L	D0-1,-(A7)
	PEA	XREF_LST(A6)
	MOVE.L	D2,-(A7)
	MOVE.L	XREF_LST(A6),D1
	BNE	INS_FXL4
	MOVEQ	#0,D0
INS_FXL3	MOVE.L	D1,-(A7)	relocation code
	BSR	GSP
	LEA	12(A7),A7
	MOVEA.L	XREF_LST(A6),A2	reset . .
	ADDA.L	D0,A2		. . A2
	MOVEM.L	(A7)+,D0-1
	RTS
;
INS_FXL4	MOVEA.L	D1,A2
INS_FXL1	MOVE.B	(A2),D2   length
	BEQ.S	INS_FXL2  found
	EXT.W	D2
	LEA	1(A2,D2.W),A2
	BRA.S	INS_FXL1
;
INS_FXL2	MOVE.L	A2,D0
	SUB.L	XREF_LST(A6),D0	length so far
	MOVEQ	#2,D1		relocation code
	ADD.L	D0,(A7)		set length required
	BRA	INS_FXL3
;
INS_ER84	MOVEQ	#84,D0
	BRA	INS_ER
INS_ER59	MOVEQ	#59,D0
	BRA	INS_WARN
INS_WARN1	MOVEQ	#-1,D0
	BRA	INS_WARN
INS_WARN2	MOVEQ	#-2,D0
	BRA	INS_WARN
INS_ER1	MOVEQ	#1,D0
	BRA	INS_ER
INS_ER64	MOVEQ	#64,D0
	BRA	INS_ER
INS_ER63	MOVEQ	#63,D0
	BRA	INS_ER
INS_ER61	MOVEQ	#61,D0
	BRA	INS_ER
INS_ER24	MOVEQ	#24,D0
	BRA.S	INS_ER
INS_ER25	MOVEQ	#25,D0
	BRA.S	INS_ER
INS_ER2	MOVEQ	#2,D0
	BRA.S	INS_ER
INS_ER4	MOVEQ	#4,D0
	BRA.S	INS_ER
INS_ER5	MOVEQ	#5,D0
INS_ER	PEA	INS_LP1
INS_WARN	MOVEA.L	TEMR_L(A6),A0       -> error list
	MOVE.W	D0,([A0])           enter error number
	ADDQ.L	#2,(A0)             step pointer
	RTS
;
INS_V1	MOVE.L	D7,-(A7)  free D7 for use
	MOVE.B	(A4),D6   prepare for adj
	BTST	#4,DIP(A6)          low_ea? . . .
	BNE	INS_LOW             . . . yes
INS_V5	LSR.B	#4,D6
	MOVE.B	D4,D7
	ANDI.B	#$38,D7
	CMPI.B	#$28,D7
	BNE.S	INS_V4
	BTST	#0,D0	label 'N'? . .
	BNE	INS_ABS	. . yes
;	CMPI.B	#5,D0
;	BEQ	INS_ABS
	BRA	INS_NPC
INS_V4	ANDI.B	#$30,D7
	BEQ	INS_VN    normal
	CMPI.B	#$20,D7
	BEQ	INS_VA    n(An) or LAB
	BMI	INS_BCC
;
; n(A,X) or LAB(X) - adj = 0,2,4
;
	BTST	#3,D4     INS PC?
	BEQ.S	INS_V4A   no
	BFEXTU	D4{25:3},D7         bits 4-6 of D4.B
	CMPI.B	#7,D7
	BEQ	INS_PZC
	BTST	#0,D0	LABEL N? . .
	BEQ	INS_V4A	. . no
	BSET	#7,-1(A3,D1.W)      base suppress
	ANDI.B	#$C0,1(A3)          clear mode/reg
	ORI.B	#$30,1(A3)          & set it to 6/0
INS_V4A	ANDI.W	#7,D6
	BEQ	INS_VLP2   nothing to do
	BSR	INS_VBIT
	CMPI.B	#2,D6
	BEQ	INS_VNW
	BCLR	#0,-2(A3,D1.W)
	MOVE.B	D2,-1(A3,D1.W)  set bytes const in [EXT]1
	BTST	#29,D6	XREF? . .
	BEQ	INS_VC4   . . no
	BCLR	D0,D3	compress 4
	ADDQ.W	#1,D0
	BCLR	D0,D3
	MOVE.L	(A7)+,D7	replace D7
	SWAP	D0
	MOVE.B	#9,D0
	SWAP	D0
	BSR	INS_FXD
	MOVE.B	#1,(A2)+	B
	SUBQ.B	#1,D2
	MOVE.B	D2,(A2)+
	BRA	INS_XDA
;
INS_LOW	BFEXTU	D6{25:3},D7        adj
	BEQ	INS_LOW2
	CMPI.B	#4,D7
	BGE	INS_V5    OK
	BFEXTU	D4{26:2},D7
	CMPI.B	#3,D7
	BNE	INS_V5    OK
INS_LOW1	MOVE.L	(A7)+,D7  restore D7
	BRA	INS_ER2   ---->
INS_LOW2	BTST	#3,D6     'ZPC'
	BEQ	INS_LOW1  ---->
	BFEXTU	D4{26:3},D7
	BEQ	INS_V5    OK
	BRA	INS_LOW1  ---->
;
INS_PZC	BTST	#3,(A4)
	BEQ	INS_V4A   PC
	BSET	#7,-1(A3,D1.W)      base suppress
	BRA	INS_VN1   ZPC
;
; n(An) or LAB - adj = 0,4,6
;
INS_VA	ANDI.W	#7,D6
	BEQ	INS_VLP2
	BSR	INS_VBIT
	CMPI.B	#4,D6
	BEQ.S	INS_VAWN   word
	BTST	#6,D4
	BEQ.S	INS_VA1   1st EA
	BCLR	#0,(A3)   set
	BRA.S	INS_VA2  mode
INS_VA1	BCLR	#5,1(A3)  to 4
INS_VA2	SUBQ.W	#1,D0
	BCLR	D0,D3
	ADDQ.W	#1,D0
	BRA	INS_VC4
;
; LAB + 'PC' LABEL
;
; D6 = adj
;
INS_NPC	ANDI.W	#7,D6
	BEQ	INS_VLP2
	BSR	INS_VBIT  sets D0.W for compression
	CMPI.B	#2,D6     D6=2 for LAB, XREF & NON_PC
	BEQ	INS_LXRF
	BCLR	#0,1(A3)  PC 7(3) -> 7(2)
	BRA.S	INS_VAWP
INS_LXRF	MOVE.L	(A7)+,D7
	BCLR	#1,1(A3)  7(3) -> 7(1)
	CLR.W	-2(A3,D1.W)         clear [EXT]
	BSR	INS_FXD
	SUBQ.L	#2,D2     FB... goes 2 bytes earlier
	MOVE.B	#4,(A2)+  L
	SWAP	D0
	BTST	#16,D6
	BEQ	INS_LXRF1	'PC'
	MOVE.B	#$14,D0	no relocation
	BRA	INS_LXRF2
INS_LXRF1	MOVE.B	#$54,D0   absolute relocation
INS_LXRF2	SWAP	D0
	ADDQ.W	#1,D0
	BCLR	D0,D3     compress 2
	BRA	INS_XD8_1
;
INS_VAWN	BTST	#6,D4
	BEQ.S	INS_VAW1  1st EA
	EORI.B	#$C0,1(A3)          mode 7
	BRA.S	INS_VAWP             to
INS_VAW1	EORI.B	#$18,1(A3)            5
INS_VAWP	MOVE.W	D2,-2(A3,D1.W)      set WD in [EXT]1
	BTST	#29,D6	XREF? . .
	BEQ	INS_VC4	. . no
	BCLR	D0,D3	compress by 4
	ADDQ.W	#1,D0
	BCLR	D0,D3
	MOVE.L	(A7)+,D7	replace D7
	SWAP	D0
	MOVE.W	#$A,D0	W signed
	SWAP	D0
	BSR	INS_FXD
	MOVE.B	#2,(A2)+	W
	SUBQ.B	#2,D2	no [EXT]
	MOVE.B	D2,(A2)+
	BRA	INS_XDA
;
; D0   = Type LAB
; D2.L = value
; D4.B = Type INS
; D6   = actual adj
;
INS_ABS	BTST	#3,(A4)
	BNE	INS_VN1   LAB(ZPC) treated as normal
	BTST	#6,D4     m = 1 for PC
	BNE	INS_NPC
	ANDI.W	#7,D6
	BSR	INS_VBIT	sets D0 = D1/2 (words)
	CMPI.W	#2,D6
	BEQ.S	INS_ABS3
	ANDI.B	#$F8,1(A3) 7(3) -> 7(0)
	BRA.S	INS_VAWP
INS_ABS3	BCLR	#1,1(A3)   7(3) -> 7(1)
	MOVE.L	D2,-2(A3,D1.W)
	BTST	#29,D6	XREF? . .
	BEQ	INS_VC2	. . no
;
	ADDQ.W	#1,D0	compress by 2
	BCLR	D0,D3
	MOVE.L	(A7)+,D7	restore D7
	SWAP	D0
	MOVE.W	#$C,D0	L
	SWAP	D0
	BSR	INS_FXD
	MOVE.B	#4,(A2)+	L
	SUBQ.B	#2,D2	no [EXT]
	MOVE.B	D2,(A2)+	bytes to next entry
	BRA	INS_XDA
;
; normal
;
; D4 = type INS
; D0 = type LABEL
;
INS_VN	BTST	#3,(A4)   'ZPC' code? . . .
	BNE	INS_VAB   . . . yes
	MOVE.W	D4,D7
	ANDI.W	#7,D7     nn (bd must be non-zero)
	BNE.S	INS_VOD   od
	BTST	#5,-1(A3,D1.W)
	BEQ.S	INS_VOD   od
	CMPI.B	#5,D0
	BNE.S	INS_VN1   PC label
	BTST	#3,D4
	BEQ.S	INS_VN1   number INS
	BTST	#6,D4
	BNE	INS_VN1   PC or ZPC
	BSET	#7,-1(A3,D1.W)  set to MEM INDIRECT
	BNE.S	INS_VN1         was already set
	ANDI.B	#$C0,1(A3)      set mode(reg) to 6(0)
	ORI.B	#%110000,1(A3)
INS_VN1	ANDI.W	#7,D6     adj
	BEQ	INS_VLP2
	BSR	INS_VBIT
	CMPI.W	#2,D6
	BEQ.S	INS_VNW
	BCLR	#5,-1(A3,D1.W)      set BDs -> 01
	BRA	INS_VC4
INS_VNW	BCLR	#4,-1(A3,D1.W)      set BDs -> 10
	BRA	INS_XBC
;
INS_VAB	ANDI.W	#7,D6     adj (2 or 0)
	BEQ	INS_VLP2  nowt to do
	BSR	INS_VBIT  see that D3 is 'bitted'
	BTST	#6,D4     'm'
	BEQ	INS_VAB1
	BCLR	#1,(A3)   ***********
	BRA	INS_VAB2  * set 7(1)*
INS_VAB1	BCLR	#0,1(A3)  * to  7(0)*
INS_VAB2	BTST	#29,D6    ***********
	BNE	INS_XBC	XREF
	BRA	INS_BCC1
;
INS_VOD	ANDI.W	#7,D6
	BEQ	INS_VLP2  nothing to do
	BSR	INS_VBIT  see that D3 is 'bitted'
	ADD.W	D7,D7
	ADDQ.W	#1,D7
	SUB.W	D1,D7
	NEG.W	D7        D7 points to [EXT]1
	CMPI.W	#2,D6
	BEQ.S	INS_VOD1  Word od
	BCLR	#1,(A3,D7.W)        mark zero od
	BRA.S	INS_VC4
INS_VOD1	BCLR	#0,(A3,D7.W)        mark word od
INS_XBC	BTST	#29,D6	XREF? . .
	BEQ	INS_BCC1	. . no
	ADDQ.W	#1,D0
	BCLR	D0,D3	compress by 2
	MOVE.L	(A7)+,D7	replace D7
	CLR.W	(A3,D1.W)	clear insert word
	SWAP	D0
	MOVE.B	#$A,D0	W signed
	SWAP	D0
	BSR	INS_FXD
	MOVE.B	#2,(A2)+	W
	MOVE.B	D2,(A2)+	d
	BRA	INS_XDA
;
INS_BCC	ANDI.W	#7,D6     adj
	BEQ.S	INS_VLP3
	BSR.S	INS_VBIT
	CMPI.B	#4,D6
	BNE	INS_BCC3
	TST.B	D2
	BNE	INS_V3    not zero jump
	MOVE.W	D0,-(A7)
	PEA	INS_VX
INS_BCC2	CMPI.B	#$61,(A3) (used as a SR in INS_P8)
	BNE	INS_WARN1 not BSR
	BRA	INS_ER59  BSR
INS_BCC3	CMPI.W	#2,D2
	BNE	INS_BCC1
	MOVE.W	D0,-(A7)
	BSR	INS_WARN2
	MOVE.W	(A7)+,D0
INS_BCC1	MOVE.W	D2,(A3,D1.W)
	BRA.S	INS_VC2
INS_VX	MOVE.W	#$4E71,(A3)         set NOP
	MOVE.W	(A7)+,D0
	BRA.S	INS_VC4
INS_V3	MOVE.B	D2,-1(A3,D1.W)
INS_VC4	BCLR	D0,D3     compress by 4
INS_VC2	ADDQ.W	#1,D0     compress by 2
	BCLR	D0,D3
	MOVE.L	(A7)+,D7  restore D7
	BRA	INS_LP1
;
INS_VLP2	MOVE.L	(A7)+,D7
	BRA	INS_XLP
INS_VLP3	MOVE.L	(A7)+,D7
	CMPI.B	#$F2,-2(A3,D1.W)    is it FPcc?
	BNE	INS_XLP2            no, it's Bcc
	BSET	#6,-1(A3,D1.W)      mark long FBcc
	BRA	INS_XLP
;
; Sets up D3 = bits for each Word in  BINLINE
;
INS_VBIT	SWAP	D3
	ADD.W	D6,D3     S(adj)
	SWAP	D3
	MOVE.W	D3,D0
	BMI.S	INS_V2    already 'bitted'
	LSR.W	#1,D0
	MOVE.W	#1,D3
	LSL.W	D0,D3
	SUBI.W	#1,D3     fill D3 with len/2 1's
	BSET	#15,D3    mark adj occured
INS_V2	MOVE.W	D1,D0
	LSR.W	#1,D0
	RTS
;
;
; Write to file
;
;  D5   = Extra bytes > 22 to send
;  D3   = No of bytes to send (if Bit 15=0)
;         otherwise bit n (0 to 10)is set if
;         word 'n' is to be sent
;  D4.W = Length of BIN line
;
;   (This effectively closes variable INSERT gaps)
;
INS_END3	MOVEA.L	D0,A0	set XREF_IX . .
	MOVEQ	#0,D0	. . and clear D0
	BRA	INS_END2
;
INS_ENDA	SWAP	D4
INS_END	MOVE.L	D5,-(A7)  frees D5 & D6
	BEQ.S	INS_END1  no extra bytes
	MOVE.W	#500,D3   set 500 bytes to send
INS_END1	MOVEA.L	BIN_LINE(A6),A3
	MOVE.L	XREF_IX(A6),D0
	BNE	INS_END3		some XREF to do
	LEA	NOINS,A0		A0 -> zero word
INS_END2	BCLR	#15,D3
	BNE.S	PUT_BIN7
;
; No compression
;
	MOVE.W	D3,D0     no of bytes in BINLINE
INS_ENDA1	MOVE.W	(A0)+,D6  size|count to next XREF
	CMPI.W	#$100,D6
	BLT	INS_ENDA2 no more XREF
	MOVE.B	D6,D2
	BMI	INS_ENDA3 'COMMENT'
	EXT.W	D2        count
	SUB.W	D2,D3     adjust overall count
	BSR	PFPUT     D2.W bytes to o/put ...
	ADDA.W	D2,A3     ... and step past them
	ROR.W	#8,D6     swap bytes
	EXT.W	D6        1=B 2=W 4=L
	ADDA.W	D6,A3     step past insert place ..
	SUB.W	D6,D3     .. and reduce byte count
INS_ENDA3	MOVEA.L	(A0)+,A1  pointer to XREF string
	BSR	PXPUT     sends FB.. string
	BRA	INS_ENDA1
;
PUT_BIN7	MOVEQ	#-1,D2    fill D2 with -1
	BRA	PUT_BIN9A
;
; XREF.W
;
PUT_BIN11	MOVE.W	(A3)+,D5
	LSR.W	#1,D3     (must be 1)
	MOVE.W	D5,-2(A3,D0.W)      close up
	BRA	PUT_BIN9
;
; low count D0 XREF
;
PUT_BIN14	MOVE.L	(A0)+,A1  -> next FB..
	CMPI.W	#2,D6
	BEQ	PUT_BIN11 W
	BMI	PUT_BIN10 B
;
; L
;
	MOVE.L	(A3)+,D5
	LSR.W	#2,D3     skip 2 words
	MOVE.L	D5,-4(A3,D0.W)      close up
PUT_BIN9	BSR	PXPUT
PUT_BIN9A	MOVE.W	(A0)+,D6  next info
	CMPI.W	#$100,D6
	BLT	PUT_BIN12 no more XREF
	MOVE.B	D6,D2
	EXT.W	D2        d
	ROR.W	#8,D6     swap bytes
	EXT.W	D6        s
	BRA	PUT_BIN13
;
; B
;
PUT_BIN10	MOVE.W	(A3)+,D5
	LSR.W	#1,D3
	MOVE.W	D5,-2(A3,D0.W)      close up
	BSET	#31,D2    count of 2
PUT_BIN15	ROR.W	#8,D5     swap bytes
	DBF	D2,PUT_BIN17
	BSR	PXPUT
	MOVE.W	(A0)+,D6
	MOVE.W	#-1,D2    set large count
	CMPI.W	#$100,D6
	BLT	PUT_BIN16
	MOVE.W	D6,D2
	EXT.W	D2        d
	ROR.W	#8,D6
	EXT.W	D6        s
	BRA	PUT_BIN16
PUT_BIN17	BSR	PHPUT
PUT_BIN16	BCLR	#31,D2
	BNE	PUT_BIN15
PUT_BIN13	CMPI.W	#1,D2     D2.W=0 or 1 for do XREF
;                                 <0 for no more XREF
;                                 >1 for count to next XREF
	BLS	PUT_BIN14
	MOVE.W	(A3)+,D5
	SUBQ.W	#2,D0
	LSR.W	#1,D3
	BCC.S	PUT_BIN12
	MOVE.W	D5,(A3,D0.W)        close up
	BSR	PGPUT
	ADDQ.W	#2,D0     restore D0
PUT_BIN12	SUBQ.W	#2,D2     count down 2 bytes
	TST.W	D3
	BNE	PUT_BIN13 more
	SWAP	D3
	MOVE.W	D4,D0
	SUB.W	D3,D0     no of bytes to send
	BRA	PUT_BIN5
;
INS_ENDA2	MOVE.W	D3,D2
	BSR	PFPUT     send remaining bytes
PUT_BIN5	ADD.L	D0,DPCW(A6)         advance DPCW
	MOVE.L	(A7)+,D5  restore D5
;
; Now copy D5 bytes to _BIN
;   (D0 is no of bytes in BIN_LINE)
;
COB	TST.L	D5
	BEQ.S	PA_EX
	BSR	FLUSH1
	ADD.L	D5,DPCW(A6)
	MOVE.L	#CI_SZE,D1
	LEA	HEAPAD(A6),A0
	MOVEA.W	MM_ALLOC,A2
	JSR	(A2)         get space from heap
	TST.L	D0
	BNE	QER4      ---->
	MOVE.L	A0,LBUF(A6)  keep its address
	MOVE.L	#CI_SZE,D2
	DIVU	D2,D5
	BVS	QER7      ---->
	MOVEA.L	CH_OUT(A6),A0
	MOVEQ	#-1,D3
	BRA.S	COB1
COB2	BSR	CI_O
COB1	DBF	D5,COB2
	SWAP	D5
	MOVE.W	D5,D2
	BEQ.S	COB3
	BSR	CI_O
COB3	MOVE.L	#CI_SZE,D1
	LEA	HEAPAD(A6),A1
	MOVEA.L	LBUF(A6),A0
	MOVEA.W	MM_LNKFR,A2
	JSR	(A2)      release space
	BRA	PA_EX2
;
PA_EX	CMPI.L	#22,D0    * Arrange to print *
	BLE	PA_EX1    *   no more than   *
PA_EX2	MOVEQ	#22,D0    *     22 bytes     *
PA_EX1	MOVE.L	D0,D7
	BSR	C_LBUF
	MOVE.L	A6,-(A7)  keep DATA_SPACE on stack
	LEA	LBUF(A6),A0
	MOVE.W	CRT_SEC(A6),D0      current section no
	LEA	PCW(A6,D0.W*4),A6
	MOVE.W	CN_ITOHL,A2
	BSR	PA_HX     print PCW
	LEA	([A7],41+LBUF),A1
	MOVEA.L	([A7],CH_TMP),A0
;
	MOVEA.L	([A7],TMP_BUF),A3
	MOVE.W	#210,D5   max line length
PA_TF1	MOVE.W	4(A3),D3  bytes left in buffer
	BNE	PA_TF2    some
	MOVE.L	6(A3),D1  bytes left in file
	BEQ	PA_END2   EOF
PA_TF2	MOVEA.L	(A3),A3   pointer
	CMP.W	D5,D3
	BLE.S	PA_TF3
	MOVE.W	D5,D3
PA_TF3	SUB.W	D3,D5     remaining possible bytes in line
	SWAP	D5
	MOVE.W	D3,D5     keep for later
	SWAP	D5
	BRA	PA_TF4
PA_TF5	MOVE.B	(A3)+,D0
	MOVE.B	D0,(A1)+
	CMPI.B	#10,D0
PA_TF4	DBEQ	D3,PA_TF5 go on till LF
	BEQ	PA_TF7    LF found
	TST.W	D5        more to come? ...
	BEQ	QER1      ... no ----> FATAL
	MOVE.L	A1,-(A7)
	MOVE.W	#T_BUFSZE,D2
	MOVEQ	#-1,D3
	MOVEA.L	([4,A7],TMP_BUF),A0
	LEA	10(A0),A1 start position in buffer
	MOVE.L	A1,(A0)   set pointer
	MOVEA.L	([4,A7],CH_TMP),A0  ID
	MOVEQ	#IO_FSTRG,D0
	TRAP	#3
	TST.L	D0
	BEQ	PA_TF6    OK
	CMPI.B	#-10,D0
	BNE	QER1      ---->
PA_TF6	MOVEA.L	([4,A7],TMP_BUF),A3
	MOVE.W	D1,4(A3)  set bytes left in buffer
	EXT.L	D1
	SUB.L	D1,6(A3)  set bytes left in file
	MOVEA.L	(A7)+,A1
	BRA	PA_TF1
PA_TF7	MOVEA.L	([A7],TMP_BUF),A0
	MOVE.L	A3,(A0)   update pointer
	SWAP	D5
	SUB.W	D3,D5     bytes fetched
	SUB.W	D5,4(A0)
	MOVEQ	#-1,D4    mark NOT end of _TMP
	CMPI.B	#10,-1(A1)
	BNE.S	CPL1
	SUBQ.L	#1,A1     ignore LF
CPL1	MOVE.L	A1,D2
	LEA	([A7],41+LBUF),A1
	SUB.L	A1,D2     length excluding LF
	SWAP	D7
	ADD.W	D2,D7
	LEA	([A7],40+LBUF),A0
	MOVE.L	([A7],LINE_NO),D0
	BSR	LTOD      print LINE_NO
	MOVE.W	D4,-(A7)
	MOVE.W	([2,A7],PWID),D4
	SUB.W	([2,A7],PCK),D4
	SUB.W	#33,D4
	MOVEA.L	([2,A7],BIN_LINE),A6  set for printing BIN
PA_L0	SWAP	D7
	BEQ	PA_LE
	TST.W	D7
	BEQ.S	PA_L4
	LEA	([2,A7],9+LBUF),A0
	MOVEQ	#0,D5     clear D5.high
	MOVE.W	D7,D5
	CMPI.W	#10,D7    max bytes/line
	BLT.S	PA_L1
	MOVE.W	#10,D5
PA_L1	SUB.W	D5,D7     count down D7
	ROR.L	#1,D5
	MOVE.W	CN_ITOHW,A2
	BRA.S	PA_L2
PA_L3	BSR	PA_HX
PA_L2	DBF	D5,PA_L3
	BTST	#31,D5
	BEQ.S	PA_L4
	MOVE.W	CN_ITOHB,A2
	BSR	PA_HX
	MOVE.B	#32,(A0)+
PA_L4	SWAP	D7
	MOVE.W	D4,D2
	CMP.W	D4,D7
	BGT.S	PA_L5
	MOVE.W	D7,D2
PA_L5	SUB.W	D2,D7     count down D7
PA_L10	ADDI.W	#33,D2
	ADD.W	([2,A7],PCK),D2
	MOVEA.L	([2,A7],CH_PRNT),A0
	LEA	([2,A7],LBUF+8),A1
	SUBA.W	([2,A7],PCK),A1
	MOVEQ	#-1,D3
	BCLR	#0,([2,A7],F_EA)    was there an error? . . .
	BNE	PA_L9               . . . yes
	BTST	#5,([2,A7],DIP)
	BNE	PA_L8		errors only
PA_L9	MOVEQ	#IO_SSTRG,D0
	TRAP	#3
	MOVEQ	#10,D1    LF
	MOVEQ	#IO_SBYTE,D0
	TRAP	#3
PA_L8	LEA	([2,A7],41+LBUF),A0
	LEA	(A0,D4.W),A1
	MOVE.W	D7,D5
	BRA.S	PA_L6
PA_L7	MOVE.B	(A1)+,(A0)+
PA_L6	DBF	D5,PA_L7
	BSR.S	C_LBUF2
	BRA	PA_L0
;
; To clear the buffer
;
C_LBUF2	MOVEQ	#9,D1    clear 40 bytes
	MOVEA.L	6(A7),A0  DATA_SPACE
	BRA.S	C_LBUF3
C_LBUF	MOVE.W	PWID(A6),D1
	MOVEA.L	A6,A0     DATA_SPACE
	ADDQ.W	#3,D1
	LSR.W	#2,D1
C_LBUF3	MOVE.L	#$20202020,D0
	LEA	LBUF(A0),A0
C_LBUF1	MOVE.L	D0,(A0)+
	DBF	D1,C_LBUF1
	RTS
;
PA_LE	MOVE.W	(A7)+,D4
	MOVEA.L	(A7)+,A6   restore DATA_SPACE
	BPL	PA_END
;
; Now do errors
;
	MOVEQ	#-1,D5     mark 1st error if any
PA_E2	MOVEA.L	CH_PRNT(A6),A0
	MOVE.L	LINE_NO(A6),D0
	TST.W	4(A5)     End of all ERRORS?
	BEQ	PA_E1     yes
	CMP.L	(A5),D0
	BNE	PA_E1
	BSR.S	PA_EPRT
	BRA.S	PA_E2
;
PA_EPRT	MOVE.W	4(A5),D5  error number
	LEA	6(A5),A5  step to next error
PA_EPRT2	BTST	#5,DIP(A6)
	BNE	PA_PLINE  ERRORs only
PA_EPRT5	LEA	ERROR,A1
	BMI	PA_EPRT3
	ADDQ.L	#1,NO_ERRS(A6)
	LEA	ERROR,A1
	BRA	PA_EPRT4
PA_EPRT3	LEA	WARN,A1
	ADDQ.W	#1,D5     set no to 0 upwards
	ADDQ.L	#1,NO_WARNS(A6)
PA_EPRT4	BSR	UMT1      to print
	LEA	ETB,A1    errors
	ADDA.W	-2(A1,D5.W*2),A1
	BSR	UMT1
	RTS
;
PA_PLINE	BSET	#0,F_EA(A6)         mark 'error been'
	BCLR	#31,D5
	BEQ	PA_EPRT5  line no already printed
	MOVEA.L	CH_PRNT(A6),A0
	LEA	LINEN,A1
	BSR	UMT1
	LEA	LBUF(A6),A0
	MOVE.L	#"    ",(A0)+
	MOVE.W	#"  ",(A0)+
	MOVE.B	#10,(A0)  LF
	MOVE.L	LINE_NO(A6),D0
	BSR	LTOD
	MOVEQ	#7,D2
	MOVEA.L	CH_PRNT(A6),A0
	LEA	LBUF(A6),A1
	MOVEQ	#IO_SSTRG,D0
	TRAP	#3
	TST.W	D5        ERROR = + WARN. = -
	BRA	PA_EPRT5
;
LINEN	DC.W	12
	DC.B	"Line number "
;
PA_EPRT1	MOVE.W	(A5)+,D5  error no & step
	BRA	PA_EPRT2
;
PA_E1	MOVE.L	A5,-(A7)
	MOVEA.L	TEMR_L(A6),A5
	MOVE.L	(A5),D4
	LEA	4(A5),A5
	SUB.L	A5,D4
	LSR.W	#1,D4
	BRA.S	PA_E3
PA_E4	BSR.S	PA_EPRT1
PA_E3	DBF	D4,PA_E4
	MOVEA.L	(A7)+,A5
	ADDQ.L	#1,LINE_NO(A6)
	BRA	PA_DB
;
PA_END2	LEA	([A7],41+LBUF),A1
	MOVEQ	#0,D4
	BRA	CPL1
PA_END	TST.B	REL_SWTCH(A6)
	BEQ.S	PA_END11	not _o
	MOVE.L	#$2FB13,BUF(A6)     mark end of REL
	LEA	1+BUF(A6),A1
	BSR	PXPUT
PA_END11	BSR	FLUSH1
	BSR	PRERS     prepare BUF with no of errors & warnings . .
	MOVEA.L	CH_PRNT(A6),A0
	BSR	UMT1      . . and print it
	TST.W	E_COM(A6)		no 'COMMON'
	BMI	PA_END13
	BTST	#4,REL_SWTCH(A6)
	BEQ	OFF_O	'FB05' the COMMON sections
PA_END13	LEA	BUF(A6),A1
	MOVEQ	#64,D2
	MOVEQ	#FS_HEADR,D0
	TST.B	REL_SWTCH(A6)
	BEQ.S	PA_END6   not linkable
	MOVEA.L	CH_OUT1(A6),A0
	BRA.S	PA_END7
PA_END6	MOVEA.L	CH_OUT(A6),A0
PA_END7	TRAP	#3
	TST.L	D0
	BNE	QER2      ----> FATAL ERROR!!
	TST.B	FLTYP(A6)
	BEQ	PA_END12	no user choice of file type
	MOVE.B	1+FLTYP(A6),BUF+5(A6)	set user choice
	BRA	PA_END9
PA_END12	TST.B	REL_SWTCH(A6)
	BEQ.S	PA_END8   not linkable
	MOVE.B	#2,BUF+5(A6)    set  _o  to type 2
	BRA.S	PA_END9
PA_END8	MOVE.B	#1,5+BUF(A6)    set _BIN to type 1
PA_END9	MOVE.L	DATA(A6),BUF+6(A6)
	MOVEQ	#FS_HEADS,D0
	LEA	BUF(A6),A1
	TRAP	#3
	TST.L	D0
	BNE	QER2      ----> FATAL ERROR!!
;
; If we have 'FB05' COMMON sections we must truncate the file
;
	TST.W	E_COM(A6)
	BMI	PA_END14		not COMMON
	BTST	#4,REL_SWTCH(A6)
	BEQ	PA_END15		is 'FB05' COMMON
PA_END14	TST.B	REL_SWTCH(A6)
	BNE	SY5
PA_END15	MOVE.L	BIN_OUT(A6),D1
	MOVEQ	#FS_POSAB,D0
	TRAP	#3
	MOVEQ	#$4B,D0   truncate
	TRAP	#3
;
; Write _SYM
;
SY5	MOVEQ	#2,D0     count of strands
SY1	MOVE.W	SL1(A6,D0.W*2),D1
	MOVE.W	D1,BUF(A6,D0.W*2)   keep lab nos
	BSR	CHK_L
	BEQ	SY4                 no label
	MOVE.W	D1,D3
	BRA.S	SY2                 label exists
SY4	SUBA.L	A0,A0
	MOVEA.L	A0,A2
	BRA.S	SY3
SY2	BSR	GNL
	SUBA.L	A0,A2
SY3	MOVE.W	A2,6+BUF(A6,D0.W*2) keep position in chunk
	MOVE.L	A0,$3E+BUF(A6,D0.W*4)   keep (temp) chunk address
	DBF	D0,SY1
	LEA	SEC_LST(A6),A1      start of section name lists
	LEA	$C+BUF(A6),A2
	BSR	SY_N
	LEA	SINN(A6),A1
	LEA	$18+BUF(A6),A2
	BSR	SY_SL
	LEA	$3E+BUF(A6),A1
	LEA	$24+BUF(A6),A2
	BSR	SY_N
	LEA	$30+BUF(A6),A2
	BSR	SY_LL
	MOVE.W	SEC_NO(A6),$3C+BUF(A6)
	MOVEQ	#$3E,D2   length of header
	MOVEQ	#-1,D3    timeout
	MOVEA.L	CH_SYM(A6),A0
	LEA	BUF(A6),A1
	MOVEQ	#IO_SSTRG,D0
	TRAP	#3
	TST.L	D0
	BNE	QER9      ---->
	LEA	SEC_LST(A6),A4      -> 1st address
	BSR	SYM_PUTN
	LEA	SINN(A6),A4
	BSR	SYM_PUTI
	LEA	$3E+BUF(A6),A4
	BSR	SYM_PUTN
	LEA	$4A+BUF(A6),A4
	BSR	SYM_PUTI
SY_END	MOVEQ	#4,D1     close 5 files
	TST.B	REL_SWTCH(A6)
	BEQ.S	SY_END1   not linkable
	MOVEQ	#5,D1     close 6 files
SY_END1	LEA	CH_IN(A6),A3
PA_END1	MOVEQ	#IO_CLOSE,D0
	MOVEA.L	(A3)+,A0
	TRAP	#2
	DBF	D1,PA_END1
	LEA	TMP_NME(A6),A0 name of TMP
	BSR	DELETEFILE
	TST.B	REL_SWTCH(A6)
	BEQ.S	PA_END10  not linkable
	LEA	BIN_NME(A6),A0
	BSR	DELETEFILE   delete _BIN
PA_END10	MOVEQ	#0,D5     mark normal
PA_END5	MOVEQ	#IO_DELET,D4
	MOVE.W	MAC_NO(A6),D6
	BRA.S	PA_END3
PA_END4	MOVE.W	D6,D0
	BSR	PR30_FLE
PA_END3	DBF	D6,PA_END4
	BSR	REL_SPC   release any ALCHP'd space
;                             in the user heap
	TST.W	D5
	BEQ	GWAG      normal
	BRA	QEND      REQDO
;
OFF_O
;
; Rename files _o/_REL -> _BI : _BIN -> _o/_REL
;
	LEA	BIN_NME(A6),A1
	SUBQ.W	#1,(A1)	set <name>_BI
	BSR	RNAM	reset CH_OUT1 to start and rename to A1
	MOVE.L	CH_OUT(A6),CH_OUT1(A6)	switch . .
	MOVE.L	A0,CH_OUT(A6)		. . IDs
	LEA	REL_NME(A6),A1	_o/_REL
	BSR	RNAM	rename the other file
;
; Reset BIN_BUF & O_BUF for input/output
;
	CLR.W	([BIN_BUF,A6],4)
	LEA	O_BUF+4(A6),A0
	MOVE.L	A0,-4(A0)
;
; Get space for CPC. Each entry is a word PC for FBO5
;
	MOVE.W	E_COM(A6),D1	highest COMMON no (0, 1, ...)
	ADDQ.W	#1,D1		(1, 2, ...)
	EXT.L	D1
	MOVE.L	D1,D4
	ADD.L	D1,D1
	BSR	NN_LG2
	BNE	QER4	---->
	MOVE.L	A0,CPC(A6)
	BRA	OFF_3
OFF_4	CLR.W	(A0)+
OFF_3	DBF	D4,OFF_4
;
	MOVEQ	#0,D6	clear D6 to show not COM
	MOVEA.L	BIN_LINE(A6),A1
OFF_1	MOVEQ	#1,D2		for bytes wanted
	BSR	FETCHB
	MOVE.B	-(A1),D5	byte to D5 & reset A1
	CMPI.B	#$FB,D5	look for 1st 'FB12' . .
	BEQ	OFF_2	. . could be
	TST.L	D6	COM? . .
	BPL	OFF_5	. . no
OFF_6	ADDQ.W	#1,D7	increase PC
	BRA	OFF_1
OFF_5	BSR	PUT_B	send byte
	BRA	OFF_1
;
; $FB found
;
OFF_2	ADDQ.L	#1,A1
	MOVEQ	#1,D2	get one more byte
	BSR	FETCHB	get 'FBxx' . .
	MOVE.W	-(A1),D5	. . -> D5.W
	CMPI.B	#$FB,D5
	BEQ	FB_FB
	CMPI.B	#$13,D5
	BGT	QER1	---->
	CMPI.B	#1,D5
	BLT	QER1	---->
	LEA	COM_TAB,A2
	MOVE.B	D5,D2
	EXT.W	D2
	ADDA.W	-2(A2,D2.W*2),A2
	JMP	(A2)
;
; In a COMMON section all bytes are thrown away and replaced
; by 'FB05< where >'. Any of the directives FB02, FB06 & FB10
; are copied to output. Other directives (FB04, FB12 & FB13)
; end the COMMON section.
;
COM_TAB	DC.W	OFF_01-COM_TAB	1
	DC.W	OFF_01-COM_TAB	2
	DC.W	OFF_03-COM_TAB	3
	DC.W	OFF_04-COM_TAB	4
	DC.W	QER1-COM_TAB	5
	DC.W	OFF_06-COM_TAB	6
	DC.W	OFF_07-COM_TAB	7
	DC.W	QER1-COM_TAB	8
	DC.W	QER1-COM_TAB	9
	DC.W	QER1-COM_TAB	A
	DC.W	QER1-COM_TAB	B
	DC.W	QER1-COM_TAB        C
	DC.W	QER1-COM_TAB	D
	DC.W	QER1-COM_TAB	E
	DC.W	QER1-COM_TAB	F
	DC.W	OFF_010-COM_TAB	10
	DC.W	QER1-COM_TAB	11
	DC.W	OFF_012-COM_TAB	12
	DC.W	OFF_013-COM_TAB	13
;
OFF_01	BSR	PUT_W	send FBxx
OFF_01A	BSR	COP_STR	copy string
	BRA	OFF_1
;
OFF_03	MOVEQ	#4,D2	to send 4 bytes
OFF_03A	BSR	S_COM	end a current COM section (if it is)
;			and send FBxx anyway
	BSR	COP_STR1
	BRA	OFF_1
;
OFF_04	MOVEQ	#2,D2	to send 2 bytes
	BRA	OFF_03A
;
OFF_06	BSR	PUT_W	send FBxx
	BSR	COP_STR	copy string . .
	MOVEQ	#6,D2
	BSR	COP_STR1	. . and 6 bytes
	BRA	OFF_1
;
OFF_010	BSR	PUT_W	send FBxx . .
	MOVEQ	#2,D2
	BSR	COP_STR1	. . 2 bytes and . .
	BRA	OFF_01A	. . a string
;
OFF_012	MOVEQ	#2,D2
	BSR	S_COM   	switch off and send FBxx . .
	BSR	COP_STR1	. . and <id>
	MOVE.W	1(A1),D6	<id>
	NEG.W	D6
	BSET	#31,D6	switch on COM
	MOVE.W	([CPC,A6],D6.W*2,-2),D7	set  PC
	BRA	OFF_1
;
OFF_013	BSR	S_COM	switch off COM & send FB13
	BSR	FLUSH1	complete the output
	BRA	PA_END13
;
; FB07 is a request for XREF input. It shouldn't happen
; in a Dummy COMMON but, if it does, it is replaced by
; an addition to PC of the number of bytes requested.
; Outside a COMMON section the total request is just sent
; to output.
;
OFF_07	MOVEQ	#9,D2
	MOVE.B	D2,(A1)+
	BSR	FETCHB	get the smallest possible FB07
	MOVEA.L	BIN_LINE(A6),A1
	TST.L	D6
	BPL	OFF_07A	not COM
	BFEXTU	5(A1){5:3},D0
	ADD.W	D0,D7	add the appropriate number to PC
	BRA	OFF_07B
;
OFF_07A	BSR	PUT_W	send FB07 . .
	BSR	PXPUT	. . and its tail so far
;
OFF_07B	CMPI.B	#$FB,9(A1)	end? . .
	BEQ	OFF_1		. . yes
OFF_07D	MOVEQ	#3,D2	arrange to look at <id><op>/FB
	MOVE.B	D2,(A1)+
	BSR	FETCHB
	MOVEA.L	BIN_LINE(A6),A1
	TST.L	D6
	BMI	OFF_07C
	BSR	PXPUT	send <id><op>/FB
OFF_07C	CMPI.B	#$FB,3(A1)
	BNE	OFF_07D	not yet finished
	BRA	OFF_1
;
FB_FB	TST.L	D6
	BMI	OFF_6	add 1 to PC
	BSR	PUT_W	copy FBFB
	BRA	OFF_1
;
; Some subroutines for "OFF"
;
COP_STR	MOVEQ	#1,D2
	BSR	FETCHB	length of string ct
	MOVE.B	-1(A1),D2
	EXT.W	D2
	ADDQ.B	#1,-1(A1)	ct+1
COP_STR1	MOVE.B	D2,(A1)+	ct
	BSR	FETCHB
COP_STR2	MOVEA.L	BIN_LINE(A6),A1
	BRA	PXPUT
;
; End COM (if it is), anyway sending off D5.W
;  D5.W=FBxx
;  D6.31 = 0 not COM : = 1 COM
;  D6.W = COMMON <id> number (1,2,...)
;  D7.W = PC
;
S_COM	BCLR	#31,D6
	BEQ	PUT_W	it was not COM
	MOVE.B	#8,(A1)+
	MOVE.W	#$FB05,(A1)+
	EXT.L	D7
	MOVE.L	D7,(A1)+
	MOVE.W	D7,([CPC,A6],D6.W*2,-2)
	MOVE.W	D5,(A1)	send FBxx now
	BRA	COP_STR2
;
; _PUTI writes inf, _PUTN writes names to _SYM
;  A4 -> start of chunk
;
SYM_PUTI	MOVE.W	#LLEN,D2  size of chunk INF
	MOVEQ	#0,D6
	BRA	SYM_PUT
SYM_PUTN	MOVE.L	#CHLEN,D2 size of chunk NAME
	MOVEQ	#1,D6
SYM_PUT	MOVEQ	#2,D4
	MOVEQ	#-1,D3
SYM_PUT1	MOVE.L	(A4)+,D5  no strand
	BEQ	SYM_PUT2
SYM_PUT4	TST.L	D6        name? ....
	BEQ.S	SYM_PUT3  .... no
	SUB.L	D5,(D5.L) rel pointer for name end
SYM_PUT3	MOVEA.L	D5,A1
	MOVEQ	#IO_SSTRG,D0
	TRAP	#3
	TST.L	D6        name? ....
	BEQ.S	SYM_PUT6  .... no
	ADD.L	D5,(D5.L) replace absolute pointer
SYM_PUT6	TST.L	D0
	BNE	QER9      ---->
	TST.L	D6        name? ....
	BEQ.S	SYM_PUT5  .... no
	ADDQ.L	#4,D5
SYM_PUT5	MOVE.L	(D5.L),D5
	BNE	SYM_PUT4  more chunks
SYM_PUT2	DBF	D4,SYM_PUT1         count strands
	RTS
;
; On entry A1 -> chunk address
;          A2 -> output address in BUF
;
SY_SL	MOVEQ	#1,D6
	BRA.S	SY_LL1
SY_N	MOVEQ	#0,D6
	MOVE.W	#CHLEN,D3
	BRA.S	SY_L1
SY_LL	MOVEQ	#-1,D6
SY_LL1	MOVE.W	#LLEN,D3
SY_L1	MOVEQ	#2,D0     count strands
SY_L2	MOVEQ	#0,D4
	TST.L	D6
	BPL.S	SY_L3
	SUBA.L	A0,A0
	MOVE.W	BUF(A6,D0.W*2),D1
	TST.L	$3E+BUF(A6,D0.W*4)
	BEQ.S	SY_L4     no label
	BSR	LNPTR     set A0 -> LINN
	BFEXTU	D1{24:6},D2
	LSL.L	#3,D2
	NEG.L	D2
	ADD.L	A0,D2
	SUBQ.L	#8,D2     address of start of chunk
	MOVEA.L	D2,A0
	BRA.S	SY_L5
SY_L3	MOVE.L	(A1,D0.W*4),D2
	BEQ.S	SY_L4
SY_L5	ADDQ.L	#1,D4
	TST.L	D6
	BNE.S	SY_L6
	ADDQ.L	#4,D2
SY_L6	MOVE.L	(D2.L),D2
	BNE.S	SY_L5
SY_L4	TST.L	D6
	BPL.S	SY_L7
	MOVE.L	A0,$4A+BUF(A6,D0.W*4)
SY_L7	MULU	D3,D4
	MOVE.L	D4,(A2,D0.W*4)
	DBF	D0,SY_L2
	RTS
;
; Format of _SYM file:
;
; Header  0 SLi      (W) 1st label for each strand after EQU_SYM
;         6 NLi      (W) position of name for each 1st label in
;                        1st recorded chunk
;        $C SEC_LENi (L) No of bytes in strand i (Whole chunks)
;       $18 SINF_LEN (L)      "              "
;       $24 LAB_LEN  (L)      "              "
;       $30 LINF_LEN (L)      "              "
;       $3C SEC_NO   (W) Value of SEC_NO(A6)
; Body  $3E Section name lists (1, 2 and 3)
;           Section inf lists       "
;           Label name lists        "
;           Label inf lists         "
;
;  Name lists
;   ________________________________________
;  |    L     |    L    |<   names      >   |
;                 
;       |         Zero marks last chunk
;    Relative position of 1st free section
;
;  Info lists
;   _______________________________________
;  |    L     |    L    |<    info     >   |
;                 
;       |          0
;    Zero marks last chunk
;
PA_HX	SUBA.L	A1,A1
	SUBA.L	A6,A0
	JSR	(A2)
	ADDA.L	A6,A0
	ADDA.L	A1,A6
	MOVE.B	#32,(A0)+
	RTS
